{
    
    file:	Convert.pas
  
    purpose:	Contains functions, procedures for data conversion
  
    modified:	---
}
Unit gConvert;
Interface
Uses Global;
Procedure PackChar(InStr, OutStr : Pchar; Length:longint);
Procedure IntToStr(n : LongInt; OutStr: Pchar; StrLength : integer);
Function StrToInt(Instr : Pchar; StrLength : integer): LongInt;
Procedure Gray(InStr,OutStr: Pchar; StrLength: Integer);
Procedure DeGray(InStr,OutStr: Pchar; StrLength: Integer);
Function GetBitLength(n : Longint) : Integer;
Function IsPowerTwo(n : Longint): Boolean;

Implementation

Procedure PackChar(InStr, OutStr : Pchar; Length:longint);
Var
  f,j,k : Integer;
  n : Byte;
  full,slop : integer;
Begin
  Full := length div charsize;
  Slop := Length mod Charsize;

  For f := 0 to Full -1 Do 
    Begin
      n := 0;
      k := f*Charsize;
      For j := 0 to Charsize-1 do
        If InStr[k+j] = '1' Then
          n := n or Bits[j];
      OutStr[f] := Chr(n);
    End;    
  If Slop > 0 Then
    Begin
      n := 0;
      k:= Full * CharSize;
      For j := 0 to slop -1 Do
        If InStr[k+j] = '1' Then
          n := n or Bits[j];
      OutStr[Full] := Chr(n);
      OutStr[Full+1] := #0;
    End
  Else
    OutStr[Full] := #0;
End; {Packchar}


Procedure IntToStr(n : LongInt; OutStr: Pchar; StrLength : integer);
Var
  f : integer;
Begin
  For f := StrLength-1 downto 0 do
  Begin
    OutStr[f] := Char(Integer('0') + (n And 1));
    n := n Shr 1;
  End;
End; {IntToStr}

Function StrToInt(Instr : Pchar; StrLength : integer): LongInt;
Var
  f : integer;
  n : Longint;
Begin
  n := 0;
  For f := 0 to StrLength-1 Do
  Begin
    n := n Shl 1;
    n := n + (Integer(inStr[f]) - Integer('0'));
  End;
  StrToInt := n;
End; {StrToInt}

Procedure Gray(InStr,OutStr: Pchar; StrLength: Integer);
Var
  f : integer;
  Temp, last : Char;
Begin
  Temp := '0';
  For f := 0 To StrLength-1 Do
  Begin
    OutStr[f] := Char(Integer('0') + Integer(InStr[f] <> Temp));
   temp := InStr[f];
  End;
  OutStr[StrLength]:= #0;
End; {Gray}

Procedure DeGray(InStr,OutStr: Pchar; StrLength: Integer);
Var
  f : Integer;
  temp : Char;
Begin
  Temp := #0;
  For f := 0 to StrLength-1 do
  Begin
    If Instr[f] = '1' Then              
      OutStr[f] := Char(Integer('0') + ABS(Integer(Temp)-1))
    Else
      OutStr[f] := Char(Integer('0') + integer(Temp));
    Temp := Char(Integer(OutStr[f]) - Integer('0'));
  End;
  OutStr[StrLength]:= #0;
End; {DeGray}

Function GetBitLength(n : Longint) : Integer;
Var
  i : integer;
  l : Longint;
  r : Real;
Begin
  l := Abs(n);
  R := ln(l)/ln(2);
  i := Trunc(r);
  If FRac(r) > 0 Then
    inc(i);
  GetBitLength := i;
End;

Function IsPowerTwo(n : Longint): Boolean;
Var
  i : Longint;
Begin
  i := 1;
  IsPowerTwo := (( i shl GetBitLength(n)) = n);
End;

End.