Unit gEVal;
interface
Uses Objects,OMemory,OWindows,ODialogs,WinTypes,Winprocs, Global, gchrome, gGene, strings;

Type
   TgetCount = Function: Integer;
   TgetFunc = Function(b:Integer):PChar;

  PEval = ^TEval;
  TEval = Object(TObject)
        DllName : PChar;
        FunctionName : Pchar;
    Constructor init(nInfo : Pinfo);
    Function SetDll(nstr : Pchar):Boolean;
    Function GetFunctionCount:integer;
    Procedure GetFunctionName(n : integer;nBuf:Pchar;BufLen:integer);
    Function SetFunction(nstr : Pchar):Boolean;
    Function SetAlias(nStr : Pchar):Boolean;
    Function GetAliasParameters(nstr: Pchar):Pchar;
    Procedure Eval(NChrome : Pchromosome;GList : PGeneList);
    Destructor Done; Virtual;
    Private
        info : Pinfo; {Pointer to global data object}
       Buffer : Pchar;
       BuffLength: integer;
       ParamBuf : Pchar;
       BitBuf : Pchar;
       TmpBuf: Pchar;
       hDll : THandle;
       GetVal : TFarProc;
       Gval : tEvalFunc;
       GetFunction : tgetfunc;
       Getfunc : TFarproc;
       GetCount : TFarproc;
       GetFuncCount: tGetCount;
       Ok : Boolean;
       fCount : integer;
       FirstFlag : Boolean;
    Procedure Skipblanks(var buf:Pchar);
   end;



Implementation
Constructor TEval.init(nInfo : Pinfo);
Begin
  TObject.Init;
  Info := nInfo;
  Buffer := nil;
  ParamBuf := nil;
  TmpBuf := nil;
  BitBuf := nil;
  DllName := nil;
  FunctionName := nil;
  Ok := FALSE;
  hDll := 0;
  FirstFlag := True;
End;

Function TEval.SetDll(nstr : Pchar):Boolean;
Var
  f : integer;
Begin
  If hDll >= 32 THen
    FreeLibrary(hDll);
  hDll := LoadLibrary(nstr);
  If hDll >= 32 Then
  Begin
     GetCount := GetProcAddress(hDll,'GetCount');
     If GetCount <> nil Then
     Begin
       GetFuncCount := TGetCount(GetCount);
       FCount := GetFuncCount;
       Ok := TRUE;
     End
     Else
     Begin
       SetDll := False;
       Ok := False;
       Exit;
     End;
  End;
  If Ok Then
  Begin
     GetFunc := GetProcAddress(hDll,'GetFunc');
     If GetFunc <> nil Then
     Begin
       GetFunction := TGetFunc(GetFunc);
       BuffLength := 0;
       For f := 0 to Fcount-1 Do
       Begin
         Buffer := GetFunction(f);
         BuffLength := BuffLength+StrLen(Buffer);
       End;
       
       If ParamBuf <> nil Then
         StrDispose(ParamBuf);
       If TmpBuf <> nil Then
         StrDispose(TmpBuf);

       GetMem(ParamBuf,BuffLength+1);
       ParamBuf[0]:=#0;
       GetMem(TmpBuf,BuffLength+1);
       TmpBuf[0]:=#0;
       For f := 0 to Fcount-1 Do
       Begin
         Buffer := GetFunction(f);
         StrCat(ParamBuf,Buffer);
       End;

       FirstFlag := TRUE;
       Ok := TRUE;
       If DLLName <> nil Then
         StrDispose(DLLName);
       GetMem(DLLName,StrLen(nstr)+1);
       StrCopy(DLLName,nStr);
     End
     Else
     Begin
       SetDll := False;
       Ok := False;
       Exit;
     End;
  End;
  SetDll :=  (hDll >= 32 );
End;

Function TEval.GetFunctionCount : Integer;
Var
  f : integer;
Begin
 If OK Then
 Begin
    FCount := 0;
    For f := 0 to Strlen(ParamBuf)-1 do
      If ParamBuf[f] = '[' then inc(Fcount);
    GetFunctionCount := fCount;
  end
  Else
    GetFunctionCount := 0;
End;

Procedure TEval.Skipblanks(var buf : Pchar);
Begin
 While buf[0] = ' ' do
  inc(buf);
End;

Procedure TEval.GetFunctionName(n : integer;nBuf:Pchar;BufLen:integer);
Var
 f : integer;
 tmp : Pchar;
 tmp2 : Pchar;
Begin
 If Ok Then
 Begin
   if n >= fCount THen
   Begin
     nbuf[0] := #0;
     Exit;
   End;
   tmp := ParamBuf;
   For f := 0 to n do
   Begin
     tmp := StrScan(tmp,'[');
     inc(tmp);
   end;
   skipblanks(tmp);
   If tmp[0] = '"' Then
   Begin
     inc(tmp);
     Strlcopy(nBuf,tmp,BufLen);
     f := 0;
     While (nbuf[f] <> '"')and (f < Buflen) do
       inc(f);
     nbuf[f] := #0;
   End
   Else
     Strlcopy(nbuf,'Unknown',BufLen);
 End
 Else
   nbuf[0] := #0;
End;

Function TEval.SetAlias(nStr : Pchar):Boolean;
Var
  tmp,tmp1 : Pchar;
  f: integer;
  isok : Boolean;
Begin
  IsOK := False;
  If Ok Then
  Begin
    tmp := StrPos(ParamBuf,nstr);
    If Tmp = nil Then
       SetAlias := False
    Else
    Begin
      tmp := StrSCan(tmp,'"');
      inc(tmp);
      SkipBlanks(tmp);
      f := 0;
      While (f < StrLen(tmp)) and (tmp[f] <> ':') do
      Begin
        tmpBuf[f] := tmp[f];
        inc(f);
      End;
      tmpBuf[f] := #0;
      IsOk := SetFunction(tmpBuf);
      SetAlias := IsOk;     
    End;    
  End
  Else
    SetAlias := False;
  If ISOk Then
  Begin
    If FunctionName <> nil Then
       StrDispose(FunctionName);
    GetMem(FunctionName,StrLen(nstr)+1);
    StrCopy(FunctionName,nStr);
  End
End;

Function TEval.GetAliasParameters(nstr: Pchar):Pchar;
Var
  tmp,tmp1 : Pchar;
  f: integer;
Begin
  If Ok Then
  Begin
    tmp := StrPos(ParamBuf,nstr);
    If Tmp = nil Then
       GetAliasParameters := nil
    Else
    Begin
      tmp := StrSCan(tmp,':');
      inc(tmp);
      SkipBlanks(tmp);
      f := 0;
      While (f < StrLen(tmp)) and (tmp[f] <> ']') do
      Begin
        tmpBuf[f] := tmp[f];
        inc(f);
      End;
      tmpBuf[f] := #0;
      GetAliasParameters := tmpBuf;     
    End;    
  End
  Else
    GetAliasParameters := nil;
End;


Function TEval.SetFunction(nstr : Pchar):Boolean;
Begin
  If OK THen
  Begin
    GetVal := GetProcAddress(hDll,nstr);
    SetFunction := (GetVal <> nil);
    Gval := tEVALFUNC(GetVal);
    FirstFlag := True;
  End
  ELse
    SetFunction := False;
End;



Procedure TEval.Eval(NChrome : Pchromosome;GList : PGeneList);
Var
  P : Pointer;
Begin
  If FirstFlag Then
  Begin
    If BitBuf <> nil Then
      StrDispose(BitBuf);
    GetMem(BitBuf,Info^.BitLength+1);
    BitBuf[0]:=#0;
    FirstFlag := False;
  End;
  Case info^.FunctionType Of
  BitFunc:
    Begin
      nChrome^.UnPackStr(BitBuf);
      P := BitBuf;
      nChrome^.Fitness := GVal(P,Info^.BitLength);
    End;
  PAckedFunc:
    Begin
      nChrome^.Fitness := GVal(nChrome^.PackedVal,info^.BitLength);
    End;
  VectFunc:
    Begin
      nChrome^.UnpackStr(BitBuf);
      P := GList^.GetVec(BitBuf);
      nChrome^.Fitness := GVal(p,Glist^.Count);
    End;
  ValFunc:
    Begin
      nChrome^.UnpackStr(BitBuf);
      P := GList^.GetVec(BitBuf);
      nChrome^.Fitness := GVal(p,Glist^.Count);
    End;
  End;
  Nchrome^.Needs_Evaluation := False;
End;


Destructor TEval.Done;
Begin
  If hDll >= 32 THen
    FreeLibrary(hDll);
  If ParamBuf <> nil Then
    StrDispose(ParamBuf);
  If TmpBuf <> nil Then
    StrDispose(TmpBuf);
  TObject.Done;
End;
End.
