{************************************************}
{                                                }
{   ObjectWindows Demo                           }
{   Copyright (c) 1992 by Borland International  }
{                                                }
{************************************************}

unit GLine;

{$R-} { Turn off range check because Windows message parameters
        don't distinguish between Integer and Word. }

interface

uses WinTypes, Objects, OWindows, Pen, wincrt;

type
  TRpoint = Record
        x,y : Real;
    end;

  PLinePoint = ^TLinePoint;
  TLinePoint = object(TObject)
    X, Y: Real;
    Index : Integer;
    constructor Init(AX, AY: Real);
    constructor Load(var S: TStream);
    procedure Store(var S: TStream);
  end;
   Pbarseg = ^TBarseg;
   TBarSeg = Object(TObject)
       ID : Integer;
       Value : Integer;
       Constructor init(nID,nValue:integer);
       Function GetVal : Integer;
       Procedure SetVal(nValue:integer);
       Procedure Clear;
   end;

  PLine = ^TLine;
  TLine = object(TObject)
    Points: PCollection;
    LinePen: PPen;
      s1,s2 : TRPoint;
      D1,d2 : TRPoint;
      ScaleX, ScaleY : Real;
      Offsetsrc : tRPoint;
      OffsetDest : tPoint;
    constructor Init(APen: PPen);
    constructor Load(var S: TStream);
    destructor Done; virtual;
    procedure AddPoint(AX, AY: Real);
    Procedure Clear;
    Procedure SetTranslate(src1x,src1y,src2x,Src2Y:Real;dest1: TREct);
    Procedure Translate(sx,sy : Real; var dx: integer; var dy : integer);
    procedure Draw(ADC: HDC); virtual;
    Procedure DrawLast(ADC: HDC);
    procedure Store(var S: TStream);
  end;

  PRoute = ^TRoute;
  Troute = object(Tline)
          Procedure Draw(ADC: HDC); Virtual;
  end;

  Pbar = ^TBar;
  TBar = Object(TObject)
      R : TRect;
      Bars  : PCollection;
      BarPrush : Hbrush;
      OldBrsuh : Hbrush;
      MaxHVal : Integer;
      BarPen : PPen;
      Constructor init ;
      Destructor Done; virtual;
      Procedure Clear;
      Procedure SetVal(nID,nValue:integer);
      Function  GetVal(nId:integer):integer;
      Procedure Freeall;
      Procedure Inc(nID:integer);
      Function GetMax : integer;
      Procedure SetRectSize(nR:TRect);
      Procedure SetPopSize(nPop : Integer);
      Procedure SetmaxVal(nval : integer);
      Procedure Draw(ADC : HDC);
 end;
const
  RLinePoint: TStreamRec = (
    ObjType: 200;
    VmtLink: Ofs(TypeOf(TLinePoint)^);
    Load: @TLinePoint.Load;
    Store: @TLinePoint.Store);

  RLine: TStreamRec = (
    ObjType: 201;
    VmtLink: Ofs(TypeOf(TLine)^);
    Load: @TLine.Load;
    Store: @TLine.Store);

Implementation

uses WinProcs;
Constructor TBarSeg.init(nID,nValue:integer);
Begin
  TObject.Init;
  Value := nValue;
  ID := nID;
End;

Function TBarSeg.GetVal : Integer;
Begin
  GetVal := Value;
End;

Procedure TBarSeg.SetVal(nValue:integer);
Begin
  Value := nValue;
End;

Procedure TBarSeg.Clear;
Begin
  Value := 0;
end;

{--------------------------------------------------}
{ TDPoints's method implementations:               }
{--------------------------------------------------}

constructor TLinePoint.Init(AX, AY: Real);
begin
  X := AX;
  Y := AY;
end;

constructor TLinePoint.Load(var S: TStream);
begin
  S.Read(X, SizeOf(X));
  S.Read(Y, SizeOf(Y));
end;

procedure TLinePoint.Store(var S: TStream);
begin
  S.Write(X, SizeOf(X));
  S.Write(Y, SizeOf(Y));
end;

constructor TLine.Init(APen: PPen);
begin
  inherited Init;
  Points := New(PCollection, Init(50,50));
  LinePen := New(PPen, Init(APen^.Style, APen^.Width, APen^.Color));
end;

constructor TLine.Load(var S: TStream);
begin
  Points := PCollection(S.Get);
  LinePen := PPen(S.Get);
end;

destructor TLine.Done;
begin
  Dispose(LinePen, Done);
  Dispose(Points, Done);
  inherited Done;
end;

Procedure TLine.Clear;
Begin
  Points^.FreeAll;
End;

Procedure TLine.SetTranslate(src1x,src1y,src2x,Src2Y:Real;dest1: TREct);
Begin
  ScaleX := (src2x-src1x)/(dest1.right-dest1.Left);
  ScaleY := (src2y-src1y)/(dest1.Bottom-dest1.Top);
  OffsetSrc.x := src1x;
  OffsetSrc.y := src1y;
  OffsetDest.x := dest1.Left;
  OffsetDest.y := dest1.Top;
End;


Procedure TLine.Translate(sx,sy : Real;Var dx :integer; Var dy:integer);
Begin
  dx := OffsetDest.x+ Round(((sx-OffsetSrc.x)/ScaleX));
  dy := OffsetDest.y+ Round(((sy-OffsetSrc.y)/Scaley));
End;

procedure TLine.AddPoint(AX, AY: Real);
begin
  Points^.Insert(New(PLinePoint, Init(AX, AY)));
end;

procedure TLine.Draw(ADC: HDC);
var
  First: Boolean;

  procedure DrawTheLine(P: PLinePoint); far;
  Var
    x,y : integer;
  begin
    Translate(P^.x,P^.y,x,y);
    if First then MoveTo(ADC, X, Y)
    else LineTo(ADC, X, Y);
    First := False;
  end;

begin
  First := True;
  LinePen^.Select(ADC);
  Points^.ForEach(@DrawTheLine);
  LinePen^.Delete;
end;

procedure TLine.DrawLast(ADC: HDC);
var
  First: Boolean;

  procedure DrawLastLine(P: PLinePoint); far;
  Var
    x,y : integer;
  begin
    Translate(P^.x,P^.y,x,y);
    if First then MoveTo(ADC, X, Y)
    else LineTo(ADC, X, Y);
    First := False;
  end;

begin
  First := True;
  LinePen^.Select(ADC);
  If Points^.count > 1 THen
  Begin
    DrawLastLine(Points^.at(Points^.Count-2));
    DrawLastLine(Points^.at(Points^.Count-1));
  End;
  LinePen^.Delete;
end;
procedure TLine.Store(var S: TStream);
begin
  S.Put(Points);
  S.Put(LinePen);
end;

procedure TRoute.Draw(ADC: HDC);
var
  First: Boolean;
  x,y : integer;
  P : PlinePoint;
  f,g : integer;
begin
  First := True;
  LinePen^.Select(ADC);
  P := Points^.at(PLinePoint(Points^.at(0))^.index);
  Translate(P^.x,P^.y,x,y);
  MoveTo(ADC, x, y);
  For f := 1 to Points^.count-1 Do
  Begin
    P := Points^.at(PLinePoint(Points^.at(f))^.index);
    Translate(P^.x,P^.y,x,y);
    LineTo(ADC, x, y);
    SetPixel(ADC,x-1,y,0);
    SetPixel(ADC,x+1,y,0);
    SetPixel(ADC,x,y-1,0);
    SetPixel(ADC,x,y+1,0);
    for g := 0 to 1000 do;

   End;
  P := Points^.at(PLinePoint(Points^.at(0))^.index);
  Translate(P^.x,P^.y,x,y);
  LineTo(ADC, x, y);
  SetPixel(ADC,x-1,y,0);
  SetPixel(ADC,x+1,y,0);
  SetPixel(ADC,x,y-1,0);
  SetPixel(ADC,x,y+1,0);
  LinePen^.Delete;
end;


Constructor TBar.init;
Begin
  inherited Init;
  Bars := New(PCollection, Init(50,50));
  BarPen := New(PPen, Init(ps_solid,1,RGB(0,0,255)));
  MaxHval := 1;
end;

Destructor TBar.Done;
Begin
  Dispose(Bars,Done);
  Dispose(BarPen,done);
  inherited done;
end;

Procedure TBar.FreeAll;
Begin
  Bars^.FreeAll;
End;

Procedure TBar.Clear;
Var
  f :integer;
Begin
  For f := 0 to bars^.Count-1 do
    PBarSeg(Bars^.at(F))^.Clear;
end;

Procedure Tbar.SetPopSize(nPop : Integer);
Var
  f : integer;
Begin
  for f := 0 to Bars^.Count-1 do
  Begin
    PbarSeg(Bars^.at(f))^.Value := round((PbarSeg(Bars^.at(f))^.Value / nPop) *100);
  End;
End;

Procedure TBar.SetVal(nID,nValue: integer);
Var
  f : integer;
  tmp : PBarSeg;
  Ok : Boolean;
Begin
  f := 0;
  Ok := False;
  While (f < Bars^.Count) and Not Ok  Do
  Begin
    ok := (PBarSeg(Bars^.at(f))^.ID = nID);
    f := f +1;
  End;
  If f < Bars^.Count Then
     PBarSeg(Bars^.at(f))^.setVal(nValue)
  else
     Bars^.Insert(New(PBarSeg,init(nId,nValue)));
End;

Function  TBar.GetVal(nId: integer):integer;
Var
  f : integer;
  Ok : Boolean;
Begin
  f := 0;
  Ok := False;
  While (f < Bars^.Count) and Not Ok  Do
  Begin
    ok := (PBarSeg(Bars^.at(f))^.ID = nID);
    f := f +1;
  End;
  If f < Bars^.Count Then
     GetVal := PBarSeg(Bars^.at(f))^.GetVal
  Else
    GetVal := 0;
End;



Procedure TBar.Inc(nID : integer);
Var
  f : integer;
  tmp : PBarSeg;
  Ok : Boolean;
Begin
  f := 0;
  Ok := False;
  While (f < Bars^.Count) and Not Ok  Do
  Begin
    ok := (PBarSeg(Bars^.at(f))^.ID = nID);
    f:= f+1;
  End;
  If f < Bars^.Count Then
     PBarSeg(Bars^.at(F))^.SetVal(PBarSeg(Bars^.at(f))^.GetVal+1)
  else
     Bars^.Insert(New(PBarSeg,init(nId,1)));
End;

Function TBar.GetMax : integer;
Var
 f : integer;
 tmpMax : integer;
 tmp : integer;
Begin
  tmpMax := 0;
  For f := 0 to Bars^.Count-1 do
  Begin
    tmp := PBarSeg(Bars^.at(f))^.GetVal;
    if tmp > tmpMax Then
       tmpMax := tmp;
  end;
  GetMax := TmpMax;
end;


Procedure TBar.SetmaxVal(nval : integer);
Begin
  MaxHVal := nVal;
end;

Procedure TBar.SetRectSize(nR : TRect);
Begin
  R := nR;
end;

Procedure TBar.Draw(ADC : HDC);
Var
  BarW : integer;
  BarScale : Real;
  Bar1,Bar2,bar3: integer;
  f,h : integer;
  BarR : Trect;
  BarBrush : HBrush;
  Pen : PPen;
Begin
    BarPen^.Select(ADC);
    BarBrush := GetStockObject(Gray_Brush);
   { OldBrush := SelectObject(ADC,BarBrush);
    }
   { BarW := Round((R.Right-R.Left)/(Bars^.Count));
    Bar1 := R.Left;
    Bar2 := R.Left+BarW;
    }for f := 0 To Bars^.count-1 do
    Begin
      Bar1 := R.Left+Round(((R.Right-1)-R.Left)/(Bars^.Count)*f);
      Bar2 := R.Left+Round(((R.Right-1)-R.Left)/(Bars^.Count)*(f+1));

      h := PBarseg(Bars^.at(f))^.GetVal ;
      If h > MaxHVal Then
        BarScale := 1
      Else
        BarScale := h/MaxHVal;
      Bar3 := R.Bottom-round(BarScale * (R.Bottom-R.Top));
      SetRect(BarR,Bar1,Bar3,Bar2,R.Bottom);
      FillRect(ADC,BarR,BarBrush);
      MoveTo(ADC,Bar1,R.bottom);
      LineTo(ADC,Bar1,Bar3);
      LineTo(ADC,Bar2,Bar3);
      LineTo(ADC,Bar2,R.Bottom);
     { Bar1 := Bar2;
      Bar2 := Bar2+BarW;     }
     End;
    { BarBrush := SelectObject(OldBrush);
     DeleteObject(BarBrush); }
     BarPen^.delete;
end;


begin
  RegisterType(RLinePoint);
  RegisterType(RLine);
end.
