Unit GLog;
Interface
Uses WinProcs,Wintypes,Objects,OMemory,OWindows,ODialogs,Strings,Windos,GConst,GGeneral,Global
,gchrome ,ggene     ,oStdDlgs,Gparse3;

Const
  lf_gap        = 101;
  lf_binval     = 103;
  lf_funcparams = 104;
  lf_fitness    = 105;
  lf_ShowConfig = 106;
  lf_Showfinal  = 107;
  lf_Append     = 108;
  lf_all        = 117;
  lf_Best_Worst = 118;
  lf_Best       = 119;


Type
   Tcontents = (All,Best_Worst,Best);

Type
  PLogSettings = ^TlogSettings;
  TLogsettings = Record
      Gap : integer;
      Binvals,FuncParams,Fitness: Boolean;
      ShowConfig,ShowFinal,Append : Boolean;
      Contents : TContents;
  end;

  PlogDlg = ^TlogDlg;
  TlogDlg = Object(TDialog)
       Settings : PLogSettings;
    Constructor Init(Aparent: PwindowsObject; AName :Pchar; nSettings : PLogSettings);
    Procedure WmInitDialog(Var Msg:TMessage); virtual wm_initDialog;
    Function CanClose: Boolean ;virtual ;
    Destructor Done; virtual;
   end;

Type
  PLogType = ^TLogType;
  TLogType = Object(TBaseWindow)
       FileOpen : Boolean;
       FileSelected : Boolean;
       FileName : array[0..fsPathName] of Char;
       Settings : TlogSettings;
     Constructor Init(AParent: PWindowsObject);
     Procedure NewStats; Virtual;
     Procedure Reset; Virtual;
     Procedure EndRun; Virtual;
     Procedure ChangeSettings;
     Destructor Done; Virtual;
     Private
       Logfile : Text;
       Buf : Pchar;
       sHour, sMinute, sSecond, shs: Word;
       Procedure OutputHeader;
       Procedure OutputFinal;
  end;

Implementation

Constructor TlogDlg.Init(Aparent: PwindowsObject; AName :Pchar; nSettings : PLogSettings);
Begin
  TDialog.Init(AParent,AName);
  Settings := nSettings;
End;

Procedure TlogDlg.WmInitDialog(Var Msg:TMessage);
Begin
 TDialog.WmInitDialog(Msg);
 Intset(Hwindow,lf_gap,Settings^.Gap);
 CheckDlgButton(Hwindow,lf_binval,Ord(Settings^.Binvals));
 CheckDlgButton(Hwindow,lf_funcparams,Ord(Settings^.FuncParams));
 CheckDlgButton(Hwindow,lf_fitness ,Ord(Settings^.Fitness));
 CheckDlgButton(Hwindow,lf_ShowConfig,Ord(Settings^.ShowConfig));
 CheckDlgButton(Hwindow,lf_Showfinal,Ord(Settings^.ShowFinal));
 CheckDlgButton(Hwindow,lf_Append,Ord(Settings^.Append));
 case Settings^.Contents of
   All: CheckRadioButton(Hwindow,lf_all,lf_best,lf_all);
   Best_Worst: CheckRadioButton(Hwindow,lf_all,lf_best,lf_Best_Worst);
   Best:  CheckRadioButton(Hwindow,lf_all,lf_best,lf_Best);
 end;
End;

Function TlogDlg.CanClose: Boolean ;
Var
  f : integer;
Begin
  CanClose := False;
  If Not IntGet(Hwindow,lf_gap,0,Info^.PoolSize,Settings^.Gap,'Population Size') Then
    Exit;
  Settings^.Binvals := Bool(IsdlgButtonChecked(Hwindow,lf_binval));
  Settings^.FuncParams := Bool(IsdlgButtonChecked(Hwindow,lf_funcparams));
  Settings^.Fitness := Bool(IsdlgButtonChecked(Hwindow,lf_fitness ));
  Settings^.ShowConfig := Bool(IsdlgButtonChecked(Hwindow,lf_ShowConfig));
  Settings^.ShowFinal := Bool(IsdlgButtonChecked(Hwindow,lf_Showfinal));
  Settings^.Append := Bool(IsdlgButtonChecked(Hwindow,lf_Append));
  For f := 117 to 119 do
    If IsDlgButtonchecked(Hwindow,f) = 1 Then
      Settings^.Contents := Tcontents(f - 117);
  CanClose := TRUE;
End;

Destructor TlogDlg.Done;
Begin
  TDialog.done;
End;




Constructor TLogType.Init(AParent: PWindowsObject);
Begin
  Inherited Init(AParent, '');
  SetFlags(Wb_MDIChild,False);
  SetFlags(Wb_Autocreate,false);
  FileOpen := False;
  FileSelected := False;
  GetMem(buf,Info^.Bitlength+1);
  With Settings do
  Begin
     Gap := 0;
     Binvals := false;
     FuncParams := False;
     Fitness:= false;
     ShowConfig:=True;
     ShowFinal:= True;
     Append := False;
     Contents := Best;
  end;
End;

Procedure TlogType.EndRun;
Begin
  If Fileopen Then
  Begin
  If Settings.ShowFinal Then
    OutputFinal;
    {$I-}
    Close(logfile);
    {$I+}
  FileOpen := False;
  End;
End;

Procedure TLogType.NewStats;
var
  j : integer;
  Cr : Pchromosome;
  Result : array[0..20] of char;
  Procedure WritelogInfo;
  var
    f: integer;
    tmpBuf:Pchar;
  Begin
    If settings.fitness Then
      Write(Logfile,'Fitness: ',Cr^.fitness:8:5,' ');
    If Settings.BinVals or Settings.FuncParams Then
      Cr^.unpackstr(Buf);
    If (Settings.funcparams) and
      ((Info^.FunctionType = Vectfunc) or (Info^.FunctionType = Vectfunc)) Then
    Begin
      tmpBuf := buf;
      For f := 0 to GeneList^.Count - 1 do
      Begin
        Pgene(GeneList^.At(f))^.GetValue(tmpbuf,result,SizeOf(Result)-1);
        Write(Logfile,f,') ',Result);
        inc(tmpbuf,Pgene(Genelist^.At(f))^.BitCount);
      End;
    End;
    If Settings.BinVals Then
      Write(Logfile,' ',buf);
    Writeln(LogFile);
  End;
Begin
  If FileOpen and (settings.gap > 0) then
  If  (Info^.Generation mod Settings.Gap = 0) Then
  Begin
    Case Settings.contents of
      All :
      Begin
        WriteLn(logfile, 'Generation: ',info^.Generation);
        For j := 0 to Pool1^.count-1 Do
        Begin
          Cr := Pool1^.at(j);
          WriteLogInfo;
        End;
      End;
      Best_Worst :
      Begin
        WriteLn(logfile, 'Generation: ',info^.Generation);
        Cr := Pool1^.at(0);
        WriteLogInfo;
        Cr := Pool1^.at(Pool1^.count-1);
        WriteLogInfo;
      End;
      Best :
      Begin
        Writeln(logfile, 'Generation: ',info^.Generation);
        Cr := Pool1^.at(0);
        WriteLogInfo;
      End;
    End;
  End;
End;

Procedure TLogType.Reset;
Begin
  If FileSelected then
  Begin
    If FileOpen Then
     {$I-}
    Begin
      Close(logfile);
      FileOpen := False;
    End;
    Assign(Logfile,filename);
    If Settings.append Then
    Begin
      Append(Logfile);
      If IOResult <> 0 Then
      Begin
        ReWrite(LogFile);
        If IOResult <> 0 Then
        Begin
          MessageBox(Hwindow,'There is a problem opening the log file. '+
              'Log file has been aborted!','File Error',mb_IconExclamation+mb_ok);
          Fileopen := False;
          FileSelected := False;
        End
        Else
        Begin
          FileOpen := TRUE;
        End;
      end
      Else
      Begin
        FileOpen := TRUE;
      End;
    end
    Else
    Begin
      FileOpen := True;
      Rewrite(logfile);
      If IOResult <> 0 Then
      Begin
          MessageBox(Hwindow,'There is a problem opening the log file. '+
              'Log file has been aborted!','File Error',mb_IconExclamation+mb_ok);
        Fileopen := False;
        FileSelected := False;
      End;
    End;
     {$I+}
  End;
  GetTime(sHour, sMinute, sSecond, shs);
  If FileOpen and Settings.ShowConfig Then
    OutputHeader;
End;

Procedure TLogType.ChangeSettings;
Begin
  IF Application^.ExecDialog(new(PLogDlg,init(@Self,'LOGDLG',@Settings))) = ID_OK then
    if Application^.ExecDialog(New(PFileDialog, Init(@Self, PChar(sd_FileSave),
      StrCopy(FileName, '*.log')))) = id_Ok then
    Begin
      If StrLen(FileName) <> 0 then
        FileSelected := True
      Else
        FileSelected := False;
     { Reset; }
    end;
End;


Procedure TLogType.OutputHeader;
var
  S, temp: array[0..50] of Char;
  tmp,TempStr : Pchar;
  f : integer;
  r : Real;
  TempS : String;
Begin
  {start time}
  Str(sHour: 2, S);
  StrCat(S, ':');
  Str(sMinute:2, Temp);
  if Temp[0] = ' ' then Temp[0] := '0';
  StrCat(S, Temp);
  StrCat(S, ':');
  Str(sSecond:2, Temp);
  if Temp[0] = ' ' then Temp[0] := '0';
  StrCat(S, Temp);
  Writeln(Logfile,'Start Time: ',s);
  {Dll settings}
  Writeln(LogFile,'Dll Name: ',Eval^.DLLName);
  Writeln(LogFile,'Function Name: ',Eval^.FunctionName);
  {Function parameters}
  If Parser^.Minimize Then
    tmp := 'Minimise Result'
  else
    tmp := 'Maximise Result';
  Writeln(LogFile,'Function''s Objective: ',tmp);
  Case Parser^.FunctionType of
    Bitfunc:
      tmp := 'Bit String';
    PackedFunc:
      tmp := 'Packed String';
    VectFunc:
      tmp := 'Vector';
    ValFunc:
      tmp := 'Values';
  end;
  Writeln(LogFile,'Function Type: ',tmp);
  Writeln(LogFile,'Bit Length: ',Info^.BitLength);
  f := Parser^.GetParamCount;
  If f = pa_NA Then
    Writeln(LogFile,'Parameter Count: ','NA')
  Else
    Writeln(LogFile,'Parameter Count: ',GeneList^.Count);
  For f := 0 to GeneList^.Count-1 Do
    WriteLn(LogFile,'Function Parameter ',f,') ', pgene(Genelist^.at(f))^.GetType);
  {end function description}
  Writeln(Logfile,'Selection type: ',Select^.GetFuncName);
  Writeln(logfile,'Recombination type: ',Cross^.GetFuncname);
  Writeln(LogFile,'Recombination Rate: ',Info^.CrossRate:8:5);
  Writeln(logfile,'Mutation type: ',Mutate^.GetFuncname);
  Writeln(LogFile,'Mutation Rate: ',info^.MutateRate:8:5);
  Writeln(LogFile,'Population Size: ',info^.PoolSize);
  Writeln(logfile);
  Writeln(LogFile,'End of Header');
  Writeln(Logfile);
End;

Procedure TLogType.OutputFinal;
var
  S, Temp: array[0..50] of Char;
  Hour, Minute, Second, hs: Word;
  hours,Mins,Secs : Integer;
  f: integer;
  tmpBuf:Pchar;
  CR : Pchromosome;
  Result : array[0..20] of char;
Begin
  GetTime(Hour, Minute, Second, hs);
  Str(Hour: 2, S);
  StrCat(S, ':');
  Str(Minute:2, Temp);
  if Temp[0] = ' ' then Temp[0] := '0';
  StrCat(S, Temp);
  StrCat(S, ':');
  Str(Second:2, Temp);
  if Temp[0] = ' ' then Temp[0] := '0';
  StrCat(S, Temp);
  Writeln(Logfile);
  Writeln(Logfile);
  Writeln(LogFile,'Final Results');
  Writeln(LogFile);
  Writeln(Logfile,'End Time:        ',s);
  Hours := ((Hour*3600+Minute*60+second)-(SHour*3600+SMinute*60+Ssecond)) div 3600;
  Mins := ((Hour*3600+Minute*60+second)-(SHour*3600+SMinute*60+Ssecond)) div 60;
  Secs := ((Hour*3600+Minute*60+second)-(SHour*3600+SMinute*60+Ssecond)) mod 60;
  Writeln(LogFile,'Total Run Time: ',hours,':',mins,':',secs);
  Writeln(Logfile,'Overall Best: ',Info^.Best:8:5);
  Writeln(LogFile,'Overall Worst: ',Info^.Worst:8:5);
  Writeln(logFile,'Last Average:  ',Info^.CurrentAv:8:5);
  Writeln(LogFile,'Last Generation: ',Info^.Generation);
  Writeln(LogFile,'Total number of function Evaluations: ' ,Info^.Evals);
  Writeln(logFile);
  Cr := Pool1^.at(0);
  Writeln(logfile,'Final Best result');
  Writeln(Logfile,'Fitness: ',Cr^.fitness:8:5,' ');
  Cr^.unpackstr(Buf);
  Writeln(Logfile,'BitString ',buf);
  If  ((Info^.FunctionType = Vectfunc) or (Info^.FunctionType = Vectfunc)) Then
  Begin
    tmpBuf := buf;
    For f := 0 to GeneList^.Count - 1 do
    Begin
       Pgene(GeneList^.At(f))^.GetValue(tmpbuf,result,SizeOf(Result)-1);
       Writeln(Logfile,'Paramter ',f,') ',Result);
       inc(tmpbuf,Pgene(Genelist^.At(f))^.BitCount);
    End;
  End;

End;

Destructor TLogType.Done;
Begin
  FreeMem(buf,Info^.Bitlength+1);
  Inherited done;
End;
End.