Unit GMeasure;
Interface
Uses Global, Objects,OMemory,OWindows,ODialogs,gpool1,gChrome;

Type
  Pmeasure = ^TMeasure;
  TMeasure = Object(TObject)
    Constructor init(nInfo: Pinfo);
    Procedure getStats(Pool1 : PPool);
    Destructor Done; Virtual;
    Private
       Info : Pinfo;
       Pool : PPool;
     Function NewWorst : Real;
     Procedure converge;
     Function better(f1,f2:Real):Boolean;
  end;

Implementation

Constructor TMeasure.init(nInfo: Pinfo);
Begin
  Tobject.init;
  Info := nInfo;
End;

Procedure TMeasure.Getstats(Pool1 : PPool);
Var
  Fitness : Real;
  f : Integer;
  TmpChrome : Pchromosome;
Begin
  Pool := Pool1;
  TmpChrome := Pchromosome(Pool^.at(0));
  Fitness := TmpChrome^.Fitness;
  Info^.CurrentBest := Fitness;
  Info^.CurrentWorst := Fitness;
  Info^.CurrentAv := Fitness;
  If Better(Info^.Worst, fitness) Then
    Info^.Worst := Fitness;

  For f := 1 to Pool^.Count-1 do
  Begin
    TmpChrome := Pchromosome(Pool^.at(f));
    Fitness := TmpChrome^.Fitness;
    Info^.CurrentAv := info^.CurrentAv + Fitness;
    If Better(fitness,info^.CurrentBest) Then
      Info^.CurrentBest := fitness;
    If Better(info^.currentWorst,fitness) Then
      Info^.CurrentWorst := fitness;
  End;
  Info^.CurrentAv := Info^.CurrentAv/Pool^.count;
  If Better(info^.Worst,Info^.CurrentWorst) Then
    info^.Worst := Info^.CurrentWorst;
  If Better(Info^.CurrentBest,Info^.Best) Then
    Info^.Best := Info^.CurrentBest;

  Converge;
    
End;

Function Tmeasure.NewWorst : Real;
Var
  d : Real;
Begin
  If info^.minimize THen
    d := -1.0e-4
  else
    d := 1.0e-4;
  If Info^.CurrentWorst = 0 then NewWorst := -d;
  If Info^.CurrentWorst > 0 Then
    NewWorst := info^.CurrentWorst*(1-d);
  If Info^.CurrentWorst < 0 Then
    NewWorst := info^.CurrentWorst*(1+d);
end; 

Procedure Tmeasure.converge;
Var
  f,g, ones: Integer;
Begin
  info^.Bias := 0;
  info^.Lost := 0;
  info^.Conv := 0;
  For f := 0 to info^.Bitlength-1 do
  Begin
    Ones := 0;
    For g := 0 to info^.poolsize -1 do
      Inc(Ones,Pchromosome(Pool^.at(g))^.GetBit(f));
    If (Ones = Pool^.count) or (ones=0) THen
      Inc(info^.lost);
    If (Ones <= info^.MinDif) or (ones >= info^.poolsize-info^.MinDif) Then
      inc(info^.Conv);
    If Ones > info^.poolsize/2 then
      info^.bias := info^.bias + ones
    else
      Info^.bias := info^.bias + (info^.poolsize-ones);
  End;
  info^.Bias := info^.Bias/(info^.poolsize*info^.bitlength);

End;


Function Tmeasure.better(f1,f2:real):Boolean;
Begin
  If info^.Minimize then
  Begin
    If f1 < f2 then
     better := True
    Else
     better := False;
  end
  Else
  Begin
    If f1 > f2 then
     better := True
    Else
     better := False;
  End;
End;

Destructor TMeasure.Done;
Begin
  Tobject.Done;
End;
End.
