Unit gMutate;
Interface
Uses Global, Strings, gChrome,Objects,OMemory,OWindows,ODialogs,gpool1;
Const
  MutateCount = 1;

Type
  TMutateFunc = Procedure(Info: PInfo;P1: Pchromosome);


Type
  PMutateType = ^TMutateType;
  TMutateType = Object(TObject)
      FuncIndx  : Integer;
      MutateFunc : TMutateFunc;
     Constructor Init(Name : Pchar);
     Procedure SetFunc(Name : Pchar);
     Function GetFuncName : Pchar;
     Function GetMutateCount : Integer;
     Function GetNameAt(Pos:integer) : Pchar;
     Procedure Mutate(Info:Pinfo; P1: Pchromosome);
     Destructor Done; Virtual;  
   End;

  PMutate = ^TMutate;
  TMutate = Object(TMutateType)
     Constructor Init(MutateName : Pchar);
     Procedure MutatePop(Pool1:PPool; Info: Pinfo);
     Destructor Done; Virtual;
  End;

Procedure Mutate1(Info:Pinfo;P1: Pchromosome);

Implementation
Type
  MutateRec = Record
      Func : TMutateFunc;
      Description : Pchar;
  End;
Const
  MutateTable : Array[0..MutateCount-1] of MutateRec = (
     (Func: Mutate1;  Description : 'normal mutation')
      );

     
Constructor TMutateType.Init(Name : Pchar);
Begin 
  TObject.Init;
  FuncIndx := 0;
  If Name = nil Then
    MutateFunc := MutateTable[FuncIndx].Func
  Else
    SetFunc(Name);
End;

Function TMutateType.GetMutateCount : Integer;
Begin
  GetMutateCount := MutateCount;
End;
  
Procedure TMutateType.SetFunc(Name : Pchar);
Var 
  f: Integer;
  found : Boolean;
Begin
  For f := 0 to MutateCount-1 Do
    If StrComp(Name,MutateTable[f].Description) = 0 Then
    Begin
      MutateFunc := MutateTable[f].func;
      FuncIndx := f;
      found := True;
    End;
  If Not Found Then
    MutateFunc := MutateTable[FuncIndx].func;
End;

Function TMutateType.GetFuncName : Pchar;
Begin
   GetFuncName := MutateTable[FuncIndx].Description;
End;

Function TMutateType.GetNameAt(Pos:integer) : Pchar;
Begin
  If (Pos < 0) Or (Pos >= MutateCount) Then
    GetNameAt := nil
  Else
    GetNameAt := MutateTable[pos].Description;
End;

Procedure TMutateType.Mutate(Info: PINFO; P1 : Pchromosome);
Begin
  MutateFunc(info, p1);
End;

Destructor TMutateType.Done;
Begin
  TObject.Done;
End;

Constructor TMutate.Init(MutateName : Pchar);
Begin
  TMutateType.init(MutateName);
End;

Procedure TMutate.MutatePop(Pool1:PPool; Info: Pinfo);
Var
  P1,P2,C1,C2: Pchromosome;
  f,g : Integer;
  last : integer;
Begin
  For  f := 0 to Info^.Poolsize - 1 do
      Mutate(Info,Pool1^.at(f));
End;

Destructor TMutate.Done;
Begin
  TMutateType.Done;
End;

Procedure Mutate1( Info:PInfo;P1: Pchromosome);
Var
  pos,f: Integer;
  Same : Boolean;
Begin
 Same := True;
 For f := 0 to Info^.BitLength -1 do
   If random <= Info^.MutateRate Then
   Begin
     P1^.ToggleBit(f);
     Same := False;
   End;
 If Not Same Then
   P1 ^.Needs_Evaluation := True;
End;


End.
