Unit gParse3;
Interface
Uses Strings,Objects,OMemory,OWindows,ODialogs,WinTypes,Global,ggene;
Const
  TokenOk         = 0;
  UnexpectedToken = -1;
  TokenTooLong    = -2;
  DataCount       = 2;
  DataTypes  : Array[0..datacount-1] of Pchar =
               ('REAL','SHORT'); 

  pa_unknown = -1;{Unknown value}
  pa_NA      = -2;{Value not applicable}
  pa_UD      = -3; {Value user defined}

Type
  TokenType = (Digit,Sign,Func,non,endexpr);
  DataToken = (tReal,tshort);
   


Type
  PParser = ^TParser;
  TParser = Object(TGeneList)
      IsUserCount : Boolean; {Does the user control the param count    }
      IsUserLength : Boolean; {Does the user control the bitlength   }
      Minimize     : Boolean;  {Should the function minimize}
      FunctionType : FunctionToken; {function type to call}
     Constructor init( ninfo : Pinfo);
     Function Parse(Nstr: PChar; nGeneList:PGeneList):Integer;
     Function ParseOk(Nstr: PChar):Integer;
     Function GetParamCount : Integer;
     Function GetBitLength : Integer;
     Function GetEntry(Indx: Integer) : Pchar;
     Destructor Done; virtual;
   Private
       CurrToken : Array[0..20] of char;
       DataType : DAtaToken; {Current DataType}
       Number : Real; {Used to hold a digit}
       Rep : integer; {number of repetions}
       Vals : array[0..10] of  real;  {Holds a gene's parameters}
       Default : Boolean; {Is a gene a deefault type}
       UserCount : Integer;   { Number of parameters ?}
       BitLength : Integer; {Length of bitstring for non gene functions }
       Pos : integer;  {Position in Token string}
       TokenStr : Pchar;  {Token String}
       GeneList : PGeneList; {internal gene list}
       BufSize : Integer; {Size of buffer}
     Procedure Skipblanks;
     Function GetToken: TokenTYpe;
     Function ReadWord : Pchar;
     Function ReadNumber: Real ;
     function MatchToken(Match : Pchar) : boolean;
     Function CreateExtGene : Boolean;
     Function CreateIntGene : Boolean;
   end;

Implementation


procedure TParser.SkipBlanks;
begin
  While TokenStr[Pos] in [' ',','] do
    Inc(Pos);
end; {skipBlanks}


Function TParser.GetToken: TokenType;
Var
  n : Tokentype;
Begin
  Skipblanks;
  if TokenStr[Pos] in ['0'..'9','.','+','-'] then
    n := Digit
  else
    if TokenStr [Pos] = ';' then
      n := endExpr
    else
      if Tokenstr[Pos] in ['a'..'z','A'..'Z'] then
        n := Func
      else
        n := Non;
  GetToken := n;
End;{Get Token}

function Tparser.ReadWord : Pchar;
var
 f : integer;
begin
  f := 0;
  CurrToken[f] := #0;
  While ((TokenStr[Pos] in
        ['a'..'z','A'..'Z','0'..'9','-','+','.']))
        and (Pos <= StrLen(TokenStr)) do
  begin
    If StrLen(CurrToken) < (SizeOf(CurrToken)-1) Then
    Begin
      CurrToken[f]:=UpCase(TokenStr[Pos]);
      CurrToken[f+1] := #0;
      Inc(f);
      Inc(Pos);
    End
    Else
    Begin
      ReadWord := '';
      Exit;
    end;
  end;
  ReadWord := CurrToken;
end; {readWord}

function TParser.ReadNumber : Real;
var 
  Code   : Integer;
  StrNum : string;
begin
  ReadWord;
  Val(CurrToken,Number,Code);
  if Code <> 0 then Number := 0;
    ReadNumber := Code;
end; {readNumber}

function TParser.MatchToken(Match : Pchar) : boolean;
var 
 j : integer;
begin
 j := pos;
 if (StrComp(readWord,match)= 0) then
   MatchToken := True
 else
 begin
   MatchToken := False;
   Pos := j;
 end;
end; {matchToken}




Function TParser.CreateExtGene : Boolean;
Var
  f : integer;
  n : TokenTYpe;
  found : Boolean;
  P : PGene;
Begin
  rep := Info^.UserCount;
  Found := False;
  CreateExtGene := False;
  For f := 0 to DataCount-1 Do
  Begin
    If (Not Found) and MatchToken(DataTypes[f]) Then
    Begin
      Found := TRue;
      Datatype := DataToken(F);
    End;
  End;
  If Not Found Then
    Exit;
  Case DataTYpe of
    tReal:
    Begin
      Default := TRue;
      n := GetToken;
      If n = Digit Then
      Begin
        For f := 1 to 3 do
        Begin
          If ReadNumber <> 0 Then
            Exit;
          vals[f-1] := number;
          n := GetToken;
        End;
        default := False;
      End;
    End;
    tShort:
    Begin
      n := GetToken;
    End;
  End;
  If n = Func Then
    If MatchToken('REP') Then
    Begin
      n := GetToken;
      If n = Digit THen
      Begin
        If ReadNumber <> 0 Then
          Exit;
        Rep := Round(number);
        IsUserCount := False;
      End
      Else
        Exit;
    End;
  For f := 1 to rep do
  Begin
    Case DataTYpe of
      tReal:
      Begin
        If Default Then
        Begin
          P := New(PGReal,init(Default,0,0,0,info));
          If P = nil Then messagebox(0,'error' ,'allocation failure',mb_ok);
          geneList^.add(P);
        end
        else
        Begin
          P := New(PGReal,init(Default,vals[0],vals[1],Round(Vals[2]),info));
          If P = nil Then messagebox(0,'error' ,'allocation failure',mb_ok);
          geneList^.add(p);
        end;
        end;
        tShort:
        Begin
          P := New(PGShort,init(info));
          If P = nil Then messagebox(0,'error' ,'allocation failure',mb_ok);
          geneList^.add(P);
        end;
    End;
  End;
  CreateExtGene := TRUE;
  Info^.SetBitLength(GeneList^.GetBitCount);
End; {create gene}

Function TParser.CreateIntGene : Boolean;
Var
  f : integer;
  n : TokenTYpe;
  found : Boolean;
  P : PGene;
Begin
  rep := UserCount;
  Found := False;
  CreateIntGene := False;

  For f := 0 to DataCount-1 Do
  Begin
    If (Not Found) and MatchToken(DataTypes[f]) Then
    Begin
      Found := TRue;
      Datatype := DataToken(F);
    End;
  End;
  If Not Found Then
    Exit;
  Case DataTYpe of
    tReal:
    Begin
      Default := True;
      n := GetToken;
      If n = Digit Then
      Begin
        For f := 1 to 3 do
        Begin
          If ReadNumber <> 0 Then
            Exit;
          vals[f-1] := number;
          n := GetToken;
        End;
        default := False;
      End;
    End;
    tShort:
    Begin
      n := GetToken;
    End;
  End;

  If n = Func Then
    If MatchToken('REP') Then
    Begin
      n := GetToken;
      If n = Digit THen
      Begin
        If ReadNumber <> 0 Then
          Exit;
        Rep := Round(number);
        IsUserCount := False;
      End
      Else
        Exit;
    End;
  For f := 1 to rep do
  Begin
    Case DataTYpe of
      tReal:
      Begin
        If default THen
        Begin
          P := New(PGReal,init(Default,0,0,0,info));
          add(P);
        end
        else
        Begin
          P := New(PGReal,init(Default,vals[0],vals[1],Round(Vals[2]),info));
          add(p);
        end;
      end;
      tShort:
      Begin
        P := New(PGShort,init(info));
         add(P);
      end;
    End; 
  End;
  CreateIntGene := True;
End; {create intgene}

Constructor TParser.init( ninfo:Pinfo);
Begin
  TGeneList.Init(ninfo);
  Pos := 0;
  info := ninfo;
  Bufsize := 0;      
  TokenStr := nil;
End; {init}

Function TParser.Parse(Nstr: PChar; nGeneList:PGeneList):Integer;
Var
  n : Tokentype;
  result : integer;
  f : integer;
  Found : Boolean;
Begin
  GeneList := ngeneList;
{  If GeneList^.Count > 0 Then
    GeneList^.DeleteAll;
}
  Genelist^.empty;
{  BitLength := 0;
 } Pos := 0;
  If TokenStr <> nil Then
    {FreeMem(Tokenstr,Bufsize); }
     StrDispose(Tokenstr);
  GetMem(TokenStr,strlen(nStr)+1);
  TokenStr[0]:=#0;
  BufSize := StrLen(nStr)+1;
  StrLCopy(TokenStr,nStr,strlen(nStr));
  Parse := Unexpectedtoken;
  n := GetToken;
  If n <> func Then
    Exit;
  If MatchToken('MIN') Then
    Info^.Minimize := TRUE
  Else
    If MatchToken('MAX') Then
      Info^.Minimize := False
    Else
    Begin
      Exit;
    End;
  n := GetToken;
  If n <> func Then
    Exit;
  Found := False;
  For f := 0 to FunctionCount-1 Do
  Begin
    If (Not Found) and MatchToken(FunctionTypes[f]) Then
    Begin
      Found := TRue;
      Info^.Functiontype := FunctionToken(F);
    End;
  End;
  If Not Found Then
    Exit;

  Case FunctionToken(Info^.FunctionType) of
    Bitfunc:
      Begin
      end;
    PackedFunc:
      Begin
      end;
    VectFunc:
       Begin
         UserCount := info^.UserCount;
         n := GetToken;
         If n <> func Then
           Exit;
         If not CreateExtGene Then
           Exit;
       End;
    ValFunc:
       Begin
         Info^.UserCount := 1;
         UserCount := 1;
            n :=  getToken;
            While (n <> endExpr) do
            Begin
             If not CreateExtGene Then
               Exit;
             n := getToken;
            end;
      End;
  end;
  Parse := TokenOK;
End;

Function TParser.ParseOk(Nstr: PChar):Integer;
Var
  n : TokenType;
  result : integer;
  f : integer;
  Found : Boolean;
Begin
{  If count >0 Then
    DeleteAll;
 }
  Empty;
  BitLength := 0;
  Pos := 0;
  If TokenStr <> nil Then
    StrDispose(Tokenstr);
  GetMem (TokenStr,strlen(nStr)+1);
  TokenStr[0]:=#0;
  BufSize := StrLen(nStr)+1;
  StrLCopy(TokenStr,nStr,strlen(nStr));

  ParseOK := UnexpectedToken;

  n := GetToken;
  If n <> func Then
    Exit;

  If MatchToken('MIN') Then
    Minimize := TRUE
  Else
    If MatchToken('MAX') Then
      Minimize := False
    Else
      Exit;

  n := GetToken;
  If n <> func Then
    Exit;

  Found := False;
  For f := 0 to FunctionCount-1 Do
  Begin
    If (Not Found) and MatchToken(FunctionTypes[f]) Then
    Begin
      Found := TRue;
      Functiontype := FunctionToken(F);
    End;
  End;
  If Not Found Then
    Exit;

  Case FunctionType of
    Bitfunc:
      Begin
        IsUserCount := False;
        IsUserLength := True;
        n := GetToken;
        If n = Digit Then
          If ReadNumber = 0 Then
          Begin
            BitLength := Round(Number);
            IsUserLength := False;
          End;
      end;
    PackedFunc:
      Begin
        IsUserCount := False;
        IsUserLength := True;
        n := GetToken;
        If n = Digit Then
          If ReadNumber = 0 Then
          Begin
            BitLength := Round(Number);
            IsUserCount := False;
          End;
      end;
    VectFunc:
       Begin
         IsUserLength := False;
         IsUserCount := True;
         UserCount := 1;
         n := GetToken;
         If n <> func Then
           Exit;
         If not CreateIntGene Then
           Exit;  
       End;
    ValFunc:
       Begin
         IsUserLength := False;
         IsUserCount := False;
         UserCount := 1;
         n :=  getToken;
         While (n = func) do
           Begin
             If not CreateIntGene Then
               Exit;   
             n := getToken;
           end;
       End;
   end;
  ParseOk := TokenOk;
End;


Function TParser.GetParamCount: Integer;
Begin
  Case FunctionType of
    Bitfunc:
       GetParamCount := pa_NA;
    PackedFunc:
       GetParamCount := pa_NA;
    VectFunc:
       If IsUserCount Then
         GetParamCount := pa_UD
       Else
         GetparamCount := Count;
    ValFunc:
       GetParamCount := Count; 
  end;
End;

Function TParser.GetBitLength: Integer;
Begin
  Case FunctionType of
    Bitfunc:
       If IsUserLength Then
         GetBitLength := pa_UD
       Else
         GetBitLength := BitLength;
    PackedFunc:
       If IsUserLength Then
         GetBitLength := pa_UD
       Else
         GetBitLength := BitLength;
    VectFunc:
       If IsUserCount Then
         GetBitLength := pa_Unknown
       Else
         GetBitLength := GetBitCount;
    ValFunc:
       GetBitlength := GetBitCount; 
  end;
end;


Function TParser.GetEntry(Indx: Integer) : Pchar;
Begin
  Case FunctionType of
    Bitfunc:
       GetEntry := nil;
    PackedFunc:
       GetEntry := nil;
    VectFunc:
       If indx < Count Then
       GetEntry := pgene(at(Indx))^.GetType;
    ValFunc:
       If indx < Count Then
       GetEntry := pgene(at(Indx))^.GetType;
  end;
End;

Destructor Tparser.done;
Begin
  If TokenStr <> nil Then
    FreeMem(TokenStr,Bufsize);
  TGeneList.Done;
End; {Done}

end.