Unit gPool1;
Interface
Uses Global,gChrome,gRandom,wintypes,Objects,OMemory,OWindows,ODialogs,winprocs,gGeneral,strings;
Type
  TCompFunc = Function (Item1, Item2 : Pointer) : Integer;

Type
  PPool = ^TPool;
  TPool = Object(TCollection)
     Info : Pinfo;
     Compare : TCompFunc;
  Constructor init(nInfo: Pinfo);
  Procedure CreateRandomPool;
  Procedure Sort;
  Procedure ShufflePool;
  Procedure Reset;
  Destructor Done; Virtual;
end;

Implementation

Function CompAsc(item1, item2 : Pointer):integer;  far;
Begin
  If Pchromosome(item1)^.Fitness < Pchromosome(item2)^.Fitness Then
     compasc := 1
  Else If Pchromosome(item1)^.Fitness > Pchromosome(item2)^.Fitness Then
     compasc := -1
  Else If Pchromosome(item1)^.Fitness = Pchromosome(item2)^.Fitness Then
     compasc := 0;
end;


Function CompDesc(item1, item2 : Pointer):integer;  far;
Begin
  If Pchromosome(item1)^.Fitness > Pchromosome(item2)^.Fitness Then
     compdesc := 1
  Else If Pchromosome(item1)^.Fitness < Pchromosome(item2)^.Fitness Then
     compdesc := -1
  Else If Pchromosome(item1)^.Fitness = Pchromosome(item2)^.Fitness Then
     compdesc := 0;
end;


Constructor TPool.init(nInfo : Pinfo);
Begin
  Info := ninfo;
  COmpare := CompDesc;
  TCollection.init(info^.PoolSize,5);
  If Info^.Minimize Then
    Compare := Compdesc
  Else
    compare := Compasc;
 { CreateRandomPool; }
End; {init}


Procedure TPool.CreateRandomPool;
Var
 Temps: String;
 Tempstr : array [0..15] of char;
 TStr : array [0..50] of char;
 f : Integer;
 msg:TMsg;
Begin
  f := 0;
  If Count <> 0 Then
    FreeAll;
  While (f <  Info^.PoolSize) and info^.running do
  Begin
    Str(f+1,TempS);
    StrCopy(TStr,'Adding chromosome ');
    StrCat(Tstr,StrPCopy(TempStr,TempS));
    StrCat(Tstr,' to pool.');
    While peekMessage(Msg,0,0,0,pm_remove) Do
      If Msg.Message = wm_quit Then Halt
        Else if not Application^.ProcessAppMsg(Msg) Then
        Begin
          TranslateMessage(msg);
           DispatchMessage(msg);
        End;
    StatusLine^.SetStatus(Tstr);
    Insert(New(Pchromosome,init(info)));
    Pchromosome(at(f))^.RandomBits;
    inc(f);
  End;
End;

Procedure Tpool.Reset;
Var
  f: integer;
Begin
  For f := 0 to count-1 do
  Begin
    Pchromosome(at(f))^.RAndomBits;
    Pchromosome(at(f))^.Needs_Evaluation := TRUE;
  end;
End;

Procedure TPool.Sort;
  PROCEDURE QSort (Left, Right : LongInt);
  VAR i, j  : LongInt;
      X,p : Pointer;
  BEGIN
        i := Left;
        j := Right;
        X := At((Left + Right) DIV 2);
        REPEAT
          WHILE Compare(At(i),X) = -1 DO Inc(i);
          WHILE Compare(X,At(j)) = -1 DO Dec(j);
          IF i <= j
             THEN BEGIN
                    p := At(i);
                    AtPut(i,At(j));
                    AtPut(j,p);
                    Inc(i);
                    Dec(j)
                END;
        UNTIL i > j;
        IF Left < j
           THEN QSort(Left,j);
        IF i < Right
           THEN QSort(i,Right)
  END;
BEGIN
  If Info^.Minimize Then
    Compare := Compdesc
  Else
    compare := Compasc;
  QSort(0,Count-1);
END;


Procedure TPool.ShufflePool;
Var
  Tmp : Pointer;
  f,g : Integer;
Begin
  For f := 0 To Count-1 Do
  Begin
    g := RandomRange(f,Count-1);
    Tmp := at(g);
    AtPut(g,at(f));
    AtPut(f,Tmp);
  End;    
End;

Destructor TPool. Done;
Begin
  TCollection.done;
end;  {done}
end.