unit GRandom;
Interface
Uses Global, Objects,OMemory,OWindows,ODialogs;

Type
PRandom = ^TRandom;
TRandom = Object(TObject)
  Constructor Init(GaussSeed,RandSeed : Integer);
  Procedure SetSeedRand(Seed: Longint);
  Procedure SetSeedGauss(Seed: Longint);
  Function IntRand(Range : Integer) : Integer;
  Procedure RandomiseRand;
  Procedure RandomiseGauss;                  
  Function RealRand(Range : Real): Real;
  Function IntGauss(Range: Integer): Integer;
  Function RealGauss(Range: Real): Real;
  Destructor Done; Virtual;
End;
Function RandomRange(R1,R2 : Integer):Integer;

Implementation
Function RandomRange(R1,R2 : Integer):Integer;
Begin
  RandomRange := R1+(Random((R2-R1)+1));
End;

Constructor TRandom.Init(GaussSeed,RandSeed : Integer);
Begin
  TObject.Init;
End;

Procedure TRandom.SetSeedRand(Seed: Longint);
Begin
  RandSeed := Seed;
End;

Procedure TRandom.SetSeedGauss(Seed: Longint);
Begin
  Abstract;
End;

Procedure TRandom.RandomiseRand;
Begin
  Randomize;
End;

Procedure TRandom.RandomiseGauss;
Begin
  Abstract;
End;

Function TRandom.IntRand(Range : Integer) : Integer;
Begin
  IntRand := Random(range);
End;

Function TRandom.RealRand(Range : Real): Real;
Begin
  Abstract;
End;

Function TRandom.IntGauss(Range: Integer): Integer;
Begin
  Abstract;
End;

Function TRandom.RealGauss(Range: Real): Real;
Begin
  Abstract;
End;

Destructor TRandom.Done;
Begin
  TObject.Done;
End;

End.