Unit gSelect;
interface
Uses Objects,OMemory,OWindows,ODialogs, gChrome, global , gpool1, strings;
Const
  SelectCount = 2;

Type
  TSelectFunc = Procedure(Pool1,Pool2:PPool;Info:Pinfo);


Type
  PSelect = ^TSelect;
  TSelect = Object(TObject)
      FuncIndx  : Integer;
      SelectFunc : TSelectFunc;
     Constructor Init(Name : Pchar);
     Procedure SetFunc(Name : Pchar);
     Function GetSelectCount: integer;
     Function GetFuncName : Pchar;
     Function GetNameAt(Pos:integer) : Pchar;
     Procedure Select(Pool1,Pool2:PPool;Info:Pinfo);
     Destructor Done; Virtual;  
   End;


Procedure Select1(Pool1,Pool2:PPool;Info:Pinfo);
Procedure Select2(Pool1,Pool2:PPool;Info:Pinfo);

Implementation

Type
  SelectRec = Record
      Func : TSelectFunc;
      Description : Pchar;
  End;
Const
  SelectTable : Array[0..SelectCount-1] of SelectRec = (
     (Func: Select1;  Description : 'Remainder Stochastic') ,
     (Func: Select2;  Description : 'Tournament')
      );

Constructor TSelect.Init(Name : Pchar);
Begin 
  TObject.Init;
  FuncIndx := 0;
  If Name = nil Then
    SelectFunc := SelectTable[FuncIndx].Func
  Else
    SetFunc(Name);
End;

Function TSelect.GetSelectCount : Integer;
Begin
  GetSelectCount := SelectCount;
End;
  
Procedure TSelect.SetFunc(Name : Pchar);
Var 
  f: Integer;
  found : Boolean;
Begin
  For f := 0 to SelectCount-1 Do
    If StrComp(Name,SelectTable[f].Description) = 0 Then
    Begin
      SelectFunc := SelectTable[f].func;
      FuncIndx := f;
      found := True;
    End;
  If Not Found Then
    SelectFunc := SelectTable[FuncIndx].func;
End;

Function TSelect.GetFuncName : Pchar;
Begin
   GetFuncName := SelectTable[FuncIndx].Description;
End;

Function TSelect.GetNameAt(Pos:integer) : Pchar;
Begin
  If (Pos < 0) Or (Pos >= SelectCount) Then
    GetNameAt := nil
  Else
    GetNameAt := SelectTable[pos].Description;
End;

Procedure TSelect.Select(Pool1,Pool2:PPool;Info:Pinfo);
Begin
  SelectFunc(Pool1,Pool2,Info);
End;

Destructor TSelect.Done;
Begin
  TObject.Done;
End;

Procedure Select1(Pool1,Pool2:PPool;Info:PInfo);
var 
  p1,p2,n : integer;
  copies : Real;
  Whole : integer;
  Part : Real;
Begin
  p1 := 0;
  p2 := 0;
  Pool1^.Sort;
  While (p2 < info^.poolSize)  and (P1 < info^.PoolSize)do
  Begin
    If info^.Minimize then
    Begin
      If Pchromosome(Pool1^.at(p1))^.Fitness = 0 Then
        Copies := Info^.Poolsize
      else
       Copies := Info^.CurrentAv/Pchromosome(Pool1^.at(p1))^.Fitness
    End
    Else
      Copies := (Pchromosome(Pool1^.at(p1))^.Fitness/Info^.CurrentAv)*
                 Info^.PoolSize/20;
    If copies > Info^.PoolSize  Then
      Copies := Info^.PoolSize;
    Whole := Trunc(Copies);

    Part := Frac(Copies);
    n :=  0;
    While (P2 < info^.PoolSize) and (n < whole)  do 
    Begin
      Pchromosome(Pool2^.at(P2))^.Overwrite(Pchromosome(Pool1^.at(p1)));
      inc(n);
      inc(p2);
    End;
    If (P2 < info^.PoolSize) and (random <= Part) Then
    Begin
      Pchromosome(Pool2^.at(P2))^.Overwrite(Pchromosome(Pool1^.at(p1)));
      inc(p2);
    End;
    inc(p1);
  End;
  Pool2^.ShufflePool;
End;

Procedure Select2(Pool1,Pool2:PPool;Info:PInfo);
var
  p1,p2,n,l : integer;
  copies : Real;
  Whole : integer;
  Part : Real;
  cr1,cr2,cr3 : Pchromosome;
  Xtra : Boolean;
Begin
  Pool1^.ShufflePool;
  n := 0;
{  Xtra := False;}
  L := Info^.poolsize;
 { If info^.poolsize mod 2 <> 0 Then
  Begin
      Xtra := True;
      l := info^.poolsize-1;
  End;
  }While n < l do
  Begin
    Cr1  := Pool1^.at(Random(Info^.Poolsize));
    Cr2  := Pool1^.at(Random(info^.poolsize));
    If Cr1^.Comp(Cr2) = 1 Then
       Cr3 := Cr1
    Else
       Cr3 := Cr2;
   Pchromosome(Pool2^.at(n))^.Overwrite(Cr3);
   inc(n);
   {Pchromosome(Pool2^.at(n))^.Overwrite(Cr3);
   inc(n); }
  End;      {
  If Xtra Then
  Begin
    Cr3  := Pool1^.at(Random(info^.poolsize));
    Pchromosome(Pool2^.at(Info^.PoolSize-1))^.Overwrite(Cr3);
  End;       }
End;

end.
