Unit GVBar1;
Interface
Uses GConst,GGeneral,Gviewdef,Global,Objects,OMemory,OWindows,ODialogs,
WinTypes,WinProcs,Strings,ggraph1,Gline,Pen;

Type

   PBarGraph = ^TBarGraph;
   TBarGraph = Object(TStatsWindow)
     ax : PHorAxis;
     ay : PVerAxis;
     Bar : PBar;
     Xmin,Xmax,Ymin,YMax,Xscale,YScale : Real;
     XAutoMin,XAutoMax,YAutoMax,YAutoMin : Boolean;
      Changed,ok : Boolean;
      Constructor init(nInfo:Pinfo;AParent:PWindowsObject;ATitle:Pchar);
      procedure Paint(PaintDC: HDC; var PaintInfo: TPaintStruct); virtual;
      Procedure Reset; virtual;
      procedure NewStats;  virtual;
      procedure WMSize(var Msg: TMessage); virtual wm_First + wm_Size;
      Function GetMaxVal :integer;
      Procedure SetMaxVal(nmaxVal : integer);
      Procedure SetMinX(nVal : Real);
      Procedure SetMaxX(nVal : Real);
      Procedure SetMinY(nVal : Real);
      Procedure SetMaxY(nVal : Real);
      Procedure SetPopSize(npop : integer);
      Destructor Done; virtual;
    Private
     XR,YR,GR : TRect;
   End;

Implementation


Constructor TBarGraph.init(nInfo:Pinfo;AParent:PWindowsObject;ATitle:Pchar);
Begin
  TStatsWindow.init(nInfo,AParent,ATitle);
  ax := New(PHorAxis,init('X'));
  ay := new(PVerAxis,init('Y'));
  xmin := 0;
  xmax := 10;
  Xscale := 10;
  ymin := 0;
  ymax := 10;
  yscale := 10;
  XAutoMin := False;
  XAutoMax := False;
  YAutoMin := False;
  YAutoMax := False;
  ok := False;
  Changed := True;
  Bar := new(PBar,init);
End;

Procedure TBarGraph.SetMinX(nVal : Real);
Begin
  If XAutoMin Then
  Begin
    If (XMin < XMax) and (nVal < Xmin) Then
    Begin
      Xmin := nVal;
      Changed := True;
    End;
    If (XMin > XMax) and (nVal > Xmin) Then
    Begin
      Xmin := nVal;
      Changed := True;
    End;
  End
  Else
  Begin
    If Xmin <> nVal Then
        Changed := True;
    Xmin := nVal;
  End;
End;

Procedure TBarGraph.SetMaxX(nVal : Real);
Begin
  If XAutoMax Then
  Begin
    If (XMin < XMax) and (nVal > Xmax) Then
    Begin
      Xmax := nVal;
      Changed := True;
    End;
    If (XMin > XMax) and (nVal < Xmax) Then
    Begin
      Xmax := nVal;
      Changed := True;
    End;
  End
  Else
  Begin
    If Xmax <> nVal then
      Changed := True;
    Xmax := nVal;
  End;
End;

Procedure TBarGraph.SetMinY(nVal : Real);
Begin
  If YAutoMin Then
  Begin
    If (YMin < YMax) and (nVal < Ymin) Then
    Begin
      Ymin := nVal;
      Changed := True;
    End;
    If (YMin > YMax) and (nVal > Ymin) Then
    Begin
      Ymin := nVal;
      Changed := True;
    End;
  end
  else
  Begin
    If Ymin <> nVal then
        Changed := True;
    YMin := nVal;
  End;
End;

Procedure TBarGraph.SetMaxY(nVal : Real);
Begin
  If YAutoMax Then
  Begin
    If (YMin < YMax) and (nVal > Ymax) Then
    Begin
      Ymax := nVal;
      Changed := True;
    End;
    If (YMin > YMax) and (nVal < Ymax) Then
    Begin
      Ymax := nVal;
      Changed := True;
    End;
  end
  else
  Begin
    If ymax <> nVal Then
       Changed := True;
    Ymax := nVal;
  End;
End;

Procedure TBarGraph.Reset;
Var
  R : Trect;
  f : Integer;
Begin
  Bar^.FreeAll;
  GetClientRect(Hwindow,R);
  InvalidateRect(HWindow,@R,True);
  Ok := False;
  TStatsWindow.reset;
end;

procedure TBarGraph.WMSize(var Msg: TMessage);
Begin
  Changed := True;
  inherited WMSize(msg);
End;


Procedure TBarGraph.NewStats;
Var
  R : TRect;
  Dc : HDc;
  pinf : TPaintStruct;
  h,w : integer;
  Src1,src2 :TRpoint;
  Dest1,dest2 : Tpoint;
Begin
   Dc := GetDc(Hwindow);
   Ok := TRue;
   Paint(DC,pinf);
   REleaseDC(HWindow,DC);
end;



procedure TBarGraph.Paint(PaintDC: HDC; var PaintInfo: TPaintStruct);
var
  R : TRect;
  h,w,h2,f : Integer;
  GRgn : HRgn;
  R2 : TRect;
begin
  GetClientRect(HWindow,R);
  If Changed Then
  Begin
    InvalidateREct(Hwindow,@R,TRUE);
    Changed := False;
    AX^.SetRange(PaintDC,Xmin,Xmax);
    AY^.SetRange(PaintDC,YMin,YMax);
    AX^.SetScale(XScale);
    AY^.SetSCale(YScale);
    h := AX^.GetMinH(PaintDC);
    w := AY^.GetMinW(PaintDC);
    h2 := AY^.GetMinH(PaintDC);
    SetRect(XR,R.Left+w,R.Bottom-h,R.Right-5,R.Bottom);
    SetRect(YR,R.Left,R.Top,R.Left+w,R.Bottom-h);
    AX^.SetRectSize(PaintDC,XR);
    AY^.SetRectSize(PaintDC,YR);
    SetRect(GR,r.Left+w,R.Top+h2,R.Right-5,R.bottom-h);
    SetRect(R2,r.left+w+14,R.Top+h2,R.Right,R.bottom-h);
    Bar^.SetRectSize(GR);
  End;
  If Ok  Then
  Begin
    Grgn := CreateRectRgnIndirect(GR);
    SelectClipRgn(PaintDC,Grgn);
    FillRect(PaintDc,R2,GetStockObject(white_brush));
    Bar^.Draw(PaintDC);
    DeleteObject(Grgn);
    Ok := False;
  End
  Else
  Begin
    FillRect(PaintDc,R2,GetStockObject(null_brush));
    Ax^.Draw(PaintDC);
    AY^.Draw(PaintDC);
    Grgn := CreateRectRgnIndirect(GR);
    FillRect(PaintDc,R2,GetStockObject(null_brush));
    SelectClipRgn(PaintDC,Grgn);
    Bar^.Draw(PaintDC);
    DeleteObject(Grgn);
  end;

end;

Function TBarGraph.GetMaxVal : integer;
Begin
  GetMaxVal := Bar^.GetMax;
end;

Procedure TBarGraph.SetPopSize(npop : integer);
Begin
  Bar^.SetPopSize(nPop);
End;

Procedure TBarGraph.SetMaxVal(nmaxVal : integer);
Begin
  Bar^.SetMaxVal(nMaxVal);
End;
Destructor TBarGraph.Done;
Begin
  Dispose(Bar,Done);
  inherited done;
end;

End.
