Unit GVGraph1;
Interface
Uses GConst,GGeneral,Gviewdef,Global,Objects,OMemory,OWindows,ODialogs,
WinTypes,WinProcs,Strings,ggraph1,Gline,Pen;

Type
  TGraphData = record
    XMin: array[0..9] of Char;
    XMax: array[0..9] of Char;
    XScale: array[0..9] of Char;
    XAttr: array[0..4] of Word;
    yMin: array[0..9] of Char;
    yMax: array[0..9] of Char;
    YScale: array[0..9] of Char;
    yAttr: array[0..4] of Word;
  end;

  PGraphDialog = ^TgraphDialog;
  TGraphDialog = object(TDialog)
    constructor Init(AParent: PWindowsObject; AName: PChar);
  end;

   PGraph = ^TGRaph;
   TGraph = Object(TStatsWindow)
     ax : PHorAxis;
     ay : PVerAxis;
     Lines : PCollection;
     Xmin,Xmax,Ymin,YMax,Xscale,YScale : Real;
     XAutoMin,XAutoMax,YAutoMax,YAutoMin : Boolean;
      Changed,ok : Boolean;
     Constructor init(nInfo:Pinfo;AParent:PWindowsObject;ATitle:Pchar);
      procedure Paint(PaintDC: HDC; var PaintInfo: TPaintStruct); virtual;
      Procedure Reset; virtual;
      procedure NewStats;  virtual;
      procedure WMSize(var Msg: TMessage); virtual wm_First + wm_Size;
      procedure WMRButtonDown(Var msg: TMEssage); Virtual wm_First + wm_RButtonDown;
      Procedure SetMinX(nVal : Real);
      Procedure SetMaxX(nVal : Real);
      Procedure SetMinY(nVal : Real);
      Procedure SetMaxY(nVal : Real);

      Destructor Done; virtual;
    Private
     Buffer : TGraphDAta;
     XR,YR,GR : TRect;
   End;

Implementation


Constructor TGraph.init(nInfo:Pinfo;AParent:PWindowsObject;ATitle:Pchar);
Begin
  TStatsWindow.init(nInfo,AParent,ATitle);
  ax := New(PHorAxis,init('X'));
  ay := new(PVerAxis,init('Y'));
  xmin := 0;
  xmax := 10;
  Xscale := 10;
  ymin := 0;
  ymax := 10;
  yscale := 10;
  XAutoMin := False;
  XAutoMax := False;
  YAutoMin := False;
  YAutoMax := False;
  ok := False;
  Changed := True;
  Lines := new(Pcollection,init(3,3));
End;

Procedure TGraph.SetMinX(nVal : Real);
Begin
  If XAutoMin Then
  Begin
    If (XMin < XMax) and (nVal < Xmin) Then
    Begin
      Xmin := nVal;
      Changed := True;
    End;
    If (XMin > XMax) and (nVal > Xmin) Then
    Begin
      Xmin := nVal;
      Changed := True;
    End;
  End;
End;

Procedure TGraph.SetMaxX(nVal : Real);
Begin
  If XAutoMax Then
  Begin
    If (XMin < XMax) and (nVal > Xmax) Then
    Begin
      Xmax := nVal;
      Changed := True;
    End;
    If (XMin > XMax) and (nVal < Xmax) Then
    Begin
      Xmax := nVal;
      Changed := True;
    End;
  End;
End;

Procedure TGraph.SetMinY(nVal : Real);
Begin
  If YAutoMin Then
  Begin
    If (YMin < YMax) and (nVal < Ymin) Then
    Begin
      Ymin := nVal;
      Changed := True;
    End;
    If (YMin > YMax) and (nVal > Ymin) Then
    Begin
      Ymin := nVal;
      Changed := True;
    End;
  End;
End;

Procedure TGraph.SetMaxY(nVal : Real);
Begin
  If YAutoMax Then
  Begin
    If (YMin < YMax) and (nVal > Ymax) Then
    Begin
      Ymax := nVal;
      Changed := True;
    End;
    If (YMin > YMax) and (nVal < Ymax) Then
    Begin
      Ymax := nVal;
      Changed := True;
    End;
  End;
End;

Procedure TGraph.Reset;
Var
  R : Trect;
  f : Integer;
Begin
  For f := 0 to Lines^.Count-1 do
    Pline(Lines^.at(f))^.Clear;
  GetClientRect(Hwindow,R);
  InvalidateRect(HWindow,@R,True);
  Ok := False;
  TStatsWindow.reset;
end;

procedure TGraph.WMSize(var Msg: TMessage);
Begin
  Changed := True;
  inherited WMSize(msg);
End;


Procedure TGraph.NewStats;
Var
  R : TRect;
  Dc : HDc;
  pinf : TPaintStruct;
  h,w : integer;
  Src1,src2 :TRpoint;
  Dest1,dest2 : Tpoint;
Begin
   Dc := GetDc(Hwindow);
   Ok := TRue;
   Paint(DC,pinf);
   REleaseDC(HWindow,DC);
end;



procedure TGraph.Paint(PaintDC: HDC; var PaintInfo: TPaintStruct);
var
  R : TRect;
  h,w,h2,f : Integer;
  GRgn : HRgn;
begin
  GetClientRect(HWindow,R);
  If Changed Then
  Begin
    InvalidateREct(Hwindow,@R,TRUE);
    Changed := False;
    AX^.SetRange(PaintDC,Xmin,Xmax);
    AY^.SetRange(PaintDC,YMin,YMax);
    AX^.SetScale(XScale);
    AY^.SetSCale(YScale);
    h := AX^.GetMinH(PaintDC);
    w := AY^.GetMinW(PaintDC);
    h2 := AY^.GetMinH(PaintDC);
    SetRect(XR,R.Left+w,R.Bottom-h,R.Right,R.Bottom);
    SetRect(YR,R.Left,R.Top,R.Left+w,R.Bottom-h);
    AX^.SetRectSize(PaintDC,XR);
    AY^.SetRectSize(PaintDC,YR);
    SetRect(GR,r.Left+w,R.Top+h2,R.Right,R.bottom-h);
    For F:= 0 To Lines^.Count -1 do
      PLine(Lines^.at(f))^.SetTRanslate(XMin,YMax,Xmax,YMin,GR);
  {
    Ax^.Draw(PaintDC);
    AY^.Draw(PaintDC);
    Grgn := CreateRectRgnIndirect(GR);
    SelectClipRgn(PaintDC,Grgn);
    for F := 0 To Lines^.count-1 do
    Pline(Lines^.at(f))^.Draw(PaintDC);
    DeleteObject(Grgn);
    ok := True;    }
  End;
  If Ok  Then
  Begin
    Grgn := CreateRectRgnIndirect(GR);
    SelectClipRgn(PaintDC,Grgn);
    for F := 0 To Lines^.count-1 do
      Pline(Lines^.at(f))^.DrawLast(PaintDC);
    DeleteObject(Grgn);
    Ok := False;
  End
  Else
  Begin
    Ax^.Draw(PaintDC);
    AY^.Draw(PaintDC);
    Grgn := CreateRectRgnIndirect(GR);
    SelectClipRgn(PaintDC,Grgn);
    for F := 0 To Lines^.count-1 do
    Pline(Lines^.at(f))^.Draw(PaintDC);
    DeleteObject(Grgn);
  end;

end;

procedure TGraph.WmRButtonDown(Var msg: TMEssage);
var
  GraphDlg: PGraphDialog;
  Temp : Real;
  ErrorPos: Integer;
begin
    Str(Xmin:3:2,Buffer.Xmin);
    Str(XMax:3:2,Buffer.XMax);
    Str(XScale:3:2,Buffer.Xscale);
    Str(ymin:3:2,Buffer.Ymin);
    Str(Ymax:3:2,Buffer.YMax);
    Str(YScale:3:2,Buffer.YScale);
    If AX^.TitleOn Then
      Buffer.Xattr[0] := bf_Checked
    Else
       Buffer.Xattr[0] := bf_Unchecked;
    If AX^.MinMaxOn Then
      Buffer.Xattr[1] := bf_Checked
    Else
       Buffer.Xattr[1] := bf_Unchecked;
    If AX^.NumOn Then
      Buffer.Xattr[2] := bf_Checked
    Else
       Buffer.Xattr[2] := bf_Unchecked;
     If XAutoMin Then
      Buffer.Xattr[3] := bf_Checked
    Else
       Buffer.Xattr[3] := bf_Unchecked;
    If XAutoMax Then
      Buffer.Xattr[4] := bf_Checked
    Else
       Buffer.Xattr[4] := bf_Unchecked;
    If AY^.TitleOn Then
      Buffer.Yattr[0] := bf_Checked
    Else
       Buffer.Yattr[0] := bf_Unchecked;
    If AY^.MinMaxOn Then
      Buffer.Yattr[1] := bf_Checked
    Else
       Buffer.Yattr[1] := bf_Unchecked;
    If AY^.NuMOn Then
      Buffer.Yattr[2] := bf_Checked
    Else
       Buffer.Xattr[2] := bf_Unchecked;
     If YAutoMin Then
      Buffer.Yattr[3] := bf_Checked
    Else
       Buffer.Yattr[3] := bf_Unchecked;
    If YAutoMax Then
      Buffer.Yattr[4] := bf_Checked
    Else
       Buffer.yattr[4] := bf_Unchecked;
  GraphDlg := New(PGraphDialog, Init(@self, 'Axis'));
  GraphDlg^.TransferBuffer := @Buffer;
  if Application^.ExecDialog(GraphDlg) <> idCancel then
  begin
    Changed := True;
    AX^.TitleOn := Buffer.Xattr[0]= bf_Checked;
    AX^.MinMaxOn := Buffer.Xattr[1] = bf_Checked;
    AX^.NumOn := Buffer.Xattr[2] = bf_Checked;
    XAutoMin := Buffer.Xattr[3] = bf_Checked;
    XAutoMax := Buffer.Xattr[4] = bf_Checked;
    AY^.TitleOn := Buffer.Yattr[0] = bf_Checked;
    AY^.MinMaxOn := Buffer.Yattr[1] = bf_Checked;
    AY^.NuMOn := Buffer.Yattr[2] = bf_Checked;
    YAutoMin := Buffer.Yattr[3] = bf_Checked;
    YAutoMax := Buffer.Yattr[4] = bf_Checked;

    Str(Xmin:3:2,Buffer.Xmin);
    Str(XMax:3:2,Buffer.XMax);
    Str(XScale:3:2,Buffer.Xscale);
    Str(ymin:3:2,Buffer.Ymin);
    Str(Ymax:3:2,Buffer.YMax);
    Str(YScale:3:2,Buffer.YScale);

    Val(Buffer.Xmin, Temp, ErrorPos);
    if ErrorPos = 0 then
      Xmin := Temp;
    Val(Buffer.Xmax, Temp, ErrorPos);
    if ErrorPos = 0 then
      Xmax := Temp;
    Val(Buffer.XScale, Temp, ErrorPos);
    if ErrorPos = 0 then
      XScale := Temp;
    Val(Buffer.Ymin, Temp, ErrorPos);
    if ErrorPos = 0 then
      Ymin := Temp;
    Val(Buffer.Ymax, Temp, ErrorPos);
    if ErrorPos = 0 then
      Ymax := Temp;
    Val(Buffer.YScale, Temp, ErrorPos);
    if ErrorPos = 0 then
      YScale := Temp;
  end;
end;

Destructor Tgraph.Done;
Begin
  Dispose(Lines,Done);
  inherited done;
end;

 constructor TGraphDialog.Init(AParent: PWindowsObject; AName: PChar);
var
  AControl: PControl;
  i: Integer;
begin
  inherited Init(AParent, AName);
  For i := 0 to 2 do
    AControl := New(PEdit, InitResource(@Self, 107+i, 9));
  for i := 0 to 3 do
    AControl := New(PRadioButton, InitResource(@Self, 102 + i));
  For i := 0 to 2 do
    AControl := New(PEdit, InitResource(@Self, 207+i, 9));
  for i := 0 to 3 do
    AControl := New(PRadioButton, InitResource(@Self, 202 + i));
end;

End.
