Unit GViewDef;
Interface
Uses GConst,Objects,OMemory,OWindows,ODialogs,WinProcs,WinTypes,Ggeneral,Global;


Type
  PstatsWindow = ^TStatsWindow;
  TStatsWindow = Object(TBaseWindow)
         Ginfo : Pinfo;
       Constructor init(nInfo:Pinfo;AParent:PWindowsObject;ATitle:Pchar);
       Procedure SetCountGap(Gap : integer); virtual;
       Procedure SetGenGap(Gap : integer); virtual;
       Procedure SetTrialGap(Gap : integer); virtual;
       Procedure Reset; Virtual;
       Function Ready : Boolean; virtual;
       Private
         TrialGap : Integer;
         GenGap : Integer;
         CountGap : Integer;
         LastTrial : Integer;
         LastGen : Integer;
         LastCount : Integer;
         PTrial : integer;
         PGen : integer;
       End;



Implementation

Constructor TStatsWindow.init(nInfo:Pinfo;AParent:PWindowsObject;ATitle:Pchar);
Begin
  TbaseWindow.init(AParent,ATitle);
  Ginfo := nInfo;
  TrialGap := -1;
  GenGap := -1;
  CountGap := -1;
  LastTrial := 0;
  LastGen := 0;
  Lastcount := 0;
  PTrial := 0;
  PGen := 0;
End;

Procedure TStatsWindow.Reset;
Begin
  LastTrial := 0;
  LastGen := 0;
  Lastcount := 0;
  PTrial := 0;
  PGen := 0;
End;

Procedure TStatsWindow.SetCountGap(Gap : integer);
Begin
  CountGap := Gap;
End;

Procedure TStatsWindow.SetGenGap(Gap : integer);
Begin
  GenGap := Gap;
End;

Procedure TStatsWindow.SetTrialGap(Gap : integer);
Begin
  TrialGap := Gap;
End;

Function TStatsWindow.Ready : Boolean;

Begin
  Ready := False;
  If PTrial > Ginfo^.CurrTrial Then
    LastGen := 0;
  PTrial := Ginfo^.CurrTrial;

  If PGen > Ginfo^.Generation Then
    LastCount := 0;
  PGen := Ginfo^.Generation;

  If (Ginfo^.Generation mod GenGap) = 0  Then
  Begin
    Ready := True;
    LastGen := Ginfo^.Generation;
  End;

  If (Ginfo^.CurrTrial mod TrialGap) = 0 Then
  Begin
    Ready := True;
    LastTrial := Ginfo^.CurrTrial;
  End;

  If (Ginfo^.CurrCount mod countGap) = 0 Then
  Begin
    Ready := True;
    LastCount := Ginfo^.CurrCount;
  End;
end;

End.