Unit GVtext;
Interface
Uses GConst,GGeneral,Gviewdef,Global,Objects,OMemory,OWindows,ODialogs,
WinTypes,WinProcs,Strings;

Type
   PVtext = ^TVtext;
   TVtext = Object(TStatsWindow)
   Constructor init(nInfo:Pinfo;AParent:PWindowsObject;ATitle:Pchar);
    procedure Paint(PaintDC: HDC; var PaintInfo: TPaintStruct); virtual;
    procedure NewStats;  virtual;
   Private
     Generation : Integer;
     CurrAv : Real;
     CurrBest :Real;
     Best : Real;
     Worst : Real;
     CurrWorst : Real;
     PerLost : Real;
   End;
Implementation

Constructor TVtext.init(nInfo:Pinfo;AParent:PWindowsObject;ATitle:Pchar);
Begin
  TStatsWindow.init(Info,AParent,ATitle);
  SetGenGap(2);
  Generation := 1;
  CurrAv := 0.0;
  CurrBest := 0.0;
  Best := 0.0;
  Worst := 0.0;
  CurrWorst := 0.0;
  PerLost := 0.0;
  attr.w := 240;
  attr.h := 180;

End;

Procedure TVtext.NewStats;
Var
  Dc : HDc;
  pinf : TPaintStruct;
Begin
 If  Ready Then
 Begin
   Generation := Info^.Generation;
   CurrAv := info^.CurrentAv;
   CurrBest := info^.CurrentBest;
   Best := info^.Best;
   Worst := info^.Worst;
   CurrWorst := info^.CurrentWorst;
   PerLost := (info^.Lost/Info^.bitlength)*100;
   Dc := GetDc(Hwindow);
   Paint(DC,pinf);
   REleaseDC(HWindow,DC);
 end;
end;


procedure TVtext.Paint(PaintDC: HDC; var PaintInfo: TPaintStruct);
var
  R,tmpr : TRect;
  S,temp : Array [0..50] of char;
  h,w : Integer;
begin
  GetClientRect(HWindow,R);
  StrlCopy(S,'Generation ',SizeOf(S)-1);
  TextOut(PaintDC,10,0,s,StrLen(s));
  Str(Generation,temp);
  StrLcat(temp,'            ',sizeof(temp)-1);
  TextOut(PaintDC,150,0,temp,StrLen(temp));

  StrlCopy(S,'Percentage lost ',SizeOf(S)-1);
  TextOut(PaintDC,10,15,s,StrLen(s));
  Str(perlost:8:5,temp);
  StrLcat(temp,'            ',sizeof(temp)-1);
  TextOut(PaintDC,150,15,temp,StrLen(temp));

  StrlCopy(S,'Current Best ',SizeOf(S)-1);
  TextOut(PaintDC,10,45,s,StrLen(s));
  Str(CurrBest:8:5,temp);
  StrLcat(temp,'            ',sizeof(temp)-1);
  TextOut(PaintDC,150,45,temp,StrLen(temp));
  setrect(R,10,60,15,65);
  StrlCopy(S,'Current Av ',SizeOf(S)-1);
  ExtTextOut(PaintDC,10,60,0,@r,s,StrLen(s),nil);
  Str(CurrAv:8:5,temp);
  StrLcat(temp,'            ',sizeof(temp)-1);
  TextOut(PaintDC,150,60,temp,StrLen(temp));

  StrlCopy(S,'Current Worst ',SizeOf(S)-1);
  TextOut(PaintDC,10,75,s,StrLen(s));
  Str(CurrWorst:8:5,temp);
  StrLcat(temp,'            ',sizeof(temp)-1);
  TextOut(PaintDC,150,75,temp,StrLen(temp));

  StrlCopy(S,'Overall Best ',SizeOf(S)-1);
  TextOut(PaintDC,10,105,s,StrLen(s));
  Str(Best:8:5,temp);
  StrLcat(temp,'            ',sizeof(temp)-1);
  TextOut(PaintDC,150,105,temp,StrLen(temp));

  StrlCopy(S,'Overall Worst ',SizeOf(S)-1);
  TextOut(PaintDC,10,120,s,StrLen(s));
  Str(Worst:8:5,temp);
  StrLcat(temp,'            ',sizeof(temp)-1);
  TextOut(PaintDC,150,120,temp,StrLen(temp));
 end;


End.
