
program GWin_2;

{$R gwin2.RES}

uses Objects,OMemory,OWindows,ODialogs, WinTypes, WinProcs, WinDos, oStdDlgs,
oStdWnds, Strings,
Gconst,BWCC,GEval,Global,GDiag1,Gparse3,{chtest,}GMeasure,GChrome,
GCross,Gmutate,GSelect,GGene,GPool1,GGeneral,GVtext,{GVGraph}tegraph,tdbar,
Glog{,tspgraph};

const
  cm_SaveState    = 200;
  cm_RestoreState = 201;

const
  DskFile = 'GWIN2.DSK';

type

  { Declare TGENApp, a TApplication descendant }
  TGENApp = object(TApplication)
    procedure InitMainWindow; virtual;
    procedure InitInstance; virtual;
  end;

  { Declare TGENWindow, a TMDIWindow descendant }
  PGENWindow = ^TGENWindow;
  TGENWindow = object(TMDIWindow)
      Log : PLogType ;
    constructor Init(ATitle: PChar; AMenu: HMenu);
    Destructor Done; Virtual; 
    procedure SetupWindow; virtual;
    procedure OpenFile(var Msg: TMessage);
      virtual cm_First + cm_MDIFileOpen;
    procedure SaveState(var Msg: TMessage);
      virtual cm_First + cm_SaveState;
    procedure RestoreState(var Msg: TMessage);
      virtual cm_First + cm_RestoreState;

    procedure WMSize(var Message: TMessage);
      virtual wm_Size;
    procedure WMTimer(var Message: TMessage);
      virtual wm_Timer;

    procedure LoadDll(Var Msg:TMessage);
      Virtual cm_First + cm_LoadDLL;
    procedure LoadFunction(Var Msg:TMessage);
      Virtual cm_First + cm_loadFunc;
    procedure FunctionStatus(Var msg:TMessage);
      Virtual cm_First + cm_FuncStat;
    procedure SelectCrossOver(Var msg:TMessage);
      Virtual cm_First + cm_SelCross;
    procedure SelectMutation(Var msg:TMessage);
      Virtual cm_First + cm_SelMutate;
    procedure SelectSelection(Var msg:TMessage);
      Virtual cm_First + cm_SelSelect;
    procedure GAStatus(Var msg:TMessage);
      Virtual cm_First + cm_Status;
    procedure SelectGeneral(Var msg:TMessage);
      Virtual cm_First + cm_General;
    procedure ViewTextStats(Var msg:TMessage);
      Virtual cm_first + cm_Vtext;
    procedure ViewGraph1(Var msg:TMessage);
      Virtual cm_first + cm_Vgraph1;
    procedure ViewGraph2(Var msg:TMessage);
      Virtual cm_first + cm_Vgraph2;
    procedure ViewGraph3(Var msg:TMessage);
      Virtual cm_first + cm_Vgraph3;
    procedure CMAbout(var Msg: Tmessage);
      virtual cm_First + cm_About;
    procedure Hindex(var Msg: TMessage); Virtual cm_first + cm_HIndex;
    procedure HHelp(var Msg: TMessage); Virtual cm_first + cm_Hh;

    procedure SetLog(Var msg:TMessage);
      Virtual cm_first + cm_Rlog;

    procedure RUN(Var msg:TMessage);
      Virtual cm_First + cm_run;
    procedure GrayMenus;
  end;

  { Declare TFileEditor, a TFileWindow desendant }
  PFileEditor = ^TFileEditor;
  TFileEditor = object(TFileWindow)
    constructor Init(AParent: PWindowsObject; AFileName: PChar);
    destructor Done; virtual;
    procedure GetWindowClass(var AWndClass: TWndClass); virtual;
    function GetClassName: PChar; virtual;
  end;

const
  RFileEditor: TStreamRec = (
    ObjType: 1000;
    VmtLink: Ofs(TypeOf(TFileEditor)^);
    Load:    @TFileEditor.Load;
    Store:   @TFileEditor.Store);

{ TFileEditor }

const
  EditorCount: Integer = 0;

type
  TMenuState = (msEnable, msDisable);

procedure MenuItems(State: TMenuState);

procedure ModifyCommand(Command: Word);
var
  NewState: Word;
begin
  NewState := mf_ByCommand;
  if State = msEnable then Inc(NewState, mf_Enabled)
  else Inc(NewState, mf_Disabled + mf_Grayed);
  EnableMenuItem(PWindow(Application^.MainWindow)^.Attr.Menu, Command,
    NewState);
end;

begin
  { Bail out if the window is already closed }
  if Application^.MainWindow^.HWindow = 0 then Exit;

  ModifyCommand(cm_FileSave);
  ModifyCommand(cm_FileSaveAs);
  ModifyCommand(cm_EditCut);
  ModifyCommand(cm_EditCopy);
  ModifyCommand(cm_EditPaste);
  ModifyCommand(cm_EditDelete);
  ModifyCommand(cm_EditClear);
  ModifyCommand(cm_EditUndo);
  ModifyCommand(cm_EditFind);
  ModifyCommand(cm_EditReplace);
  ModifyCommand(cm_EditFindNext);
end;

procedure IncEditors;
begin
  if EditorCount = 0 then MenuItems(msEnable);
  Inc(EditorCount);
end;

procedure DecEditors;
begin
  Dec(EditorCount);
  if EditorCount = 0 then MenuItems(msDisable);
end;

constructor TFileEditor.Init(AParent: PWindowsObject; AFileName: PChar);
begin
  TFileWindow.Init(AParent, '', AFileName);

  IncEditors;
end;

destructor TFileEditor.Done;
begin
  DecEditors;
  TFileWindow.Done;
end;

procedure TFileEditor.GetWindowClass(var AWndClass: TWndClass);
begin
  TFileWindow.GetWindowClass(AWndClass);
  AWndClass.hIcon := LoadIcon(HInstance, 'DNAICON');
end;

function TFileEditor.GetClassName: PChar;
begin
  GetClassName := 'FileEditor';
end;

{ Respond to "New" command by constructing, creating, and setting up a
  new TFileWindow MDI child }
{procedure TGENWindow.NewFile(var Msg: TMessage);
begin
  Application^.MakeWindow(New(PFileEditor, Init(@Self, '')));
end;
 }


Constructor TGENWindow.Init(ATitle: PChar; AMenu: HMenu);
Begin
  TMDIWindow.Init(ATitle,AMenu);
  StatusLine := New(PStatusLine, Init(@Self));
  Info := New(Pinfo,init);
  EVal := New(PEval,Init(Info));
  Parser := New(PParser,init(info));
  Cross := New(PREcombine,init(nil));
  Mutate := New(PMutate,init(nil));
  Select := New(PSelect,init(nil));
  GeneList := New(PGeneList,init(info));
  Pool1 := New(PPool,init(info));
  Pool2 := New(PPool,init(info));
  Measure := New(PMeasure,init(info));
  Eval := New(PEval,init(info));
  Log := New(PlogType,init(@self));
end;

Destructor TGENWindow.Done;
Begin
  Dispose(Eval,Done);
  Dispose(Parser,Done);
  Dispose(log,done);
  Dispose(Info,Done);

  KillTimer(HWindow, 1);
  TMDIWindow.Done;
end;

procedure TGENWindow.SetupWindow;
Var
  ErrorStr : Array[0..100] of char;
begin
  TMDIWindow.SetupWindow;
  MenuItems(msDisable);
  SetTimer(HWindow, 1, 100, Nil);
  LoadString(Hinstance,Run_err_Ofs+Info^.CanRun,Errorstr,sizeof(Errorstr));
  StatusLine^.SetStatus(ErrorStr);
end;

procedure TGenWindow. WMSize(var Message: TMessage);
begin
  TMDIWindow.WMSize(Message);

  { Always check for nil window pointers and invalid HWindow handles.
    Windows can send your main window WMSize messages while the child
    windows are being destroyed, which can produce some hard to track
    down UAEs.  }

  if (ClientWnd <> nil) and (ClientWnd^.HWindow <> 0) then
    if Message.LParamHi > 20 then
    MoveWindow(ClientWnd^.HWindow, 0, 0, Message.LParamLo, Message.LParamHi -
      StatusLineHeight, True);
  if (StatusLine <> nil) and (StatusLine^.HWindow <> 0) then
   if Message.LParamHi > 20 then
    MoveWindow(StatusLine^.HWindow, - 1, Message.LParamHi - StatusLineHeight,
    Message.LParamLo + 2, Message.LParamHi, True);

{ The -1 and +2 are to hide the left and right borders of this
Status window. It looks funny with no border at all, but it looks funny
with extra thick borders on the left and right.  This sets a happy medium.  }

end;

procedure TGenWindow.WMTimer(var Message: TMessage);
  procedure ChildTimers(PChildWindow: PWindow); far;

  begin
    If StrComp(PChildWindow^.GetClassName,'Gen-child') = 0 Then
       PBaseWindow(PChildWindow)^.TimerTick;
  end;
 
begin
  ForEach(@ChildTimers);
{  StatusLine^.TimerTick; }
end;



procedure TGENWindow.LoadDll(Var Msg:TMessage);
var
  FileName: array[0..fsPathName] of Char;
  ErrorStr : Array[0..100] of char;
begin
  StatusLine^.SetStatus('Loading DLL');
  if Application^.ExecDialog(New(PFileDialog, Init(@Self, PChar(sd_FileOpen),
      StrCopy(FileName, '*.DLL')))) = id_Ok then
  Begin
    If Eval^.SetDLL(FileName) Then
    Begin
      Info^.DLLLoaded := TRUE;
      info^.FunctionLoaded := False;
      Application^.ExecDialog(New(PGetFuncDialog,init(@self,'GETFUNC',Filename)));
    End
    Else
    Begin
      BWCCMessageBox(HWindow, FileName, 'DLL Failed to load', mb_Ok or mb_IconExclamation);
      Info^.DllLoaded := FALSE;
      Info^.FunctionLoaded := False;
    End;
  End;
  LoadString(Hinstance,Run_err_Ofs+Info^.CanRun,Errorstr,sizeof(Errorstr));
  StatusLine^.SetStatus(ErrorStr);
end;

Procedure TGENWindow.LoadFunction(Var Msg:TMessage);
Var
  ErrorStr : Array[0..100] of char;
Begin
  If not Info^.DllLoaded Then
    BWCCMessageBox(HWindow, 'No DLL is currently loaded', 'Error', mb_Ok or mb_IconExclamation)
  Else
    Application^.ExecDialog(New(PGetFuncDialog,init(@self,'GETFUNC',Eval^.DLLName)));
  LoadString(Hinstance,Run_err_Ofs+Info^.CanRun,Errorstr,sizeof(Errorstr));
  StatusLine^.SetStatus(ErrorStr);
End;


procedure TGenwindow.FunctionStatus(Var msg:TMessage);
Var
  ErrorStr : Array[0..100] of char;
Begin
  Application^.ExecDialog(New(PFuncStatusDlg,init(@self,'FUNCSTATUS')));
  LoadString(Hinstance,Run_err_Ofs+Info^.CanRun,Errorstr,sizeof(Errorstr));
  StatusLine^.SetStatus(ErrorStr);
End;

procedure TGenwindow.SelectCrossOver(Var msg:TMessage);
Var
  ErrorStr : Array[0..100] of char;
Begin
  Application^.ExecDialog(New(PCombinationDlg,init(@self,'COMBINATION')));
  LoadString(Hinstance,Run_err_Ofs+Info^.CanRun,Errorstr,sizeof(Errorstr));
  StatusLine^.SetStatus(ErrorStr);
End;

procedure TGenwindow.SelectMutation(Var msg:TMessage);
Var
  ErrorStr : Array[0..100] of char;
Begin
  Application^.ExecDialog(New(PMutateDlg,init(@self,'MUTATION')));
  LoadString(Hinstance,Run_err_Ofs+Info^.CanRun,Errorstr,sizeof(Errorstr));
  StatusLine^.SetStatus(ErrorStr);
End;

procedure TGenwindow.SelectSelection(Var msg:TMessage);
Var
  ErrorStr : Array[0..100] of char;
Begin
  Application^.ExecDialog(New(PSelectDlg,init(@self,'SELECTION')));
  LoadString(Hinstance,Run_err_Ofs+Info^.CanRun,Errorstr,sizeof(Errorstr));
  StatusLine^.SetStatus(ErrorStr);
End;

Procedure TGenwindow.HIndex(Var Msg: Tmessage);
Begin
  WinHelp(Hwindow,'gwin2.hlp',help_index,0);
End;

Procedure TGenwindow.HHelp(Var Msg: Tmessage);
Begin
  WinHelp(Hwindow,'gwin2.hlp',help_helpOnHelp,0);
End;

procedure TGenwindow.SelectGeneral(Var msg:TMessage);
Var
  ErrorStr : Array[0..100] of char;
Begin
  Application^.ExecDialog(New(PGeneralDlg,init(@self,'GENERAL')));
  LoadString(Hinstance,Run_err_Ofs+Info^.CanRun,Errorstr,sizeof(Errorstr));
  StatusLine^.SetStatus(ErrorStr);

End;

procedure TGenWindow.Graymenus;
Var
  men : HMenu;
Begin
  Men := GetMenu(HWindow);
  If info^.running Then
  Begin
    EnableMenuItem(Men,cm_LoadDLL,MF_Grayed);
    EnableMenuItem(Men,cm_LoadFunc,MF_Grayed);
    EnableMenuItem(Men,cm_General,MF_Grayed);
  End
  Else
  Begin
    EnableMenuItem(Men,cm_LoadDLL,MF_Enabled);
    EnableMenuItem(Men,cm_LoadFunc,MF_Enabled);
    EnableMenuItem(Men,cm_General,MF_Enabled);
  End;
    DrawMenuBar(HWindow);
End;

procedure TGenwindow.RUN(Var msg:TMessage);
Var
  ErrorStr : Array[0..100] of char;
  Men : HMenu;
  TrialCount,f : Integer;
  cr : Pchromosome;
  {Evals : Integer;}
  Buf : Pchar;
 Temps: String;
 Tempstr : array [0..15] of char;
 TStr : array [0..50] of char;
 nmsg:TMsg;
  procedure ChildReset(PChildWindow: PWindow); far;
  begin
    If StrComp(PChildWindow^.GetClassName,'Gen-child') = 0 Then
       PBaseWindow(PChildWindow)^.Reset;
  end;
  procedure ChildEndRun(PChildWindow: PWindow); far;
  begin
    If StrComp(PChildWindow^.GetClassName,'Gen-child') = 0 Then
       PBaseWindow(PChildWindow)^.EndRun;
  end;
  procedure ChildReady(PChildWindow: PWindow); far;
  begin
    If StrComp(PChildWindow^.GetClassName,'Gen-child') = 0 Then
       PBaseWindow(PChildWindow)^.NewStats;
  end;
Begin
  If info^.Running Then
  Begin
    If BWCCMessageBox(Hwindow,'Do You want to halt the GA','Warning',mb_IconQuestion or mb_YesNo)
      = id_yes Then
     Begin
       info^.Running := False;
       Graymenus;
       StatusLine^.SetStatus('GA Halted by user');
       Men := GetMenu(HWindow);
       ModifyMenu(Men,cm_run,MF_ByCommand,cm_run,'Run');
       DrawMenuBar(HWindow);
       ForEach(@ChildEndRun);
    end;
  End
  Else
  Begin
    If Info^.CanRun <> err_ok Then
    Begin
      LoadString(Hinstance,Run_err_Ofs+Info^.CanRun,Errorstr,sizeof(Errorstr));
      BWCCMessageBox(HWindow, ErrorStr, 'Run Error', mb_Ok or mb_IconExclamation);
      Exit;
    End;
    info^.Running := True;
    Info^.ResetRun;
    Men := GetMenu(HWindow);
    Graymenus;
    ModifyMenu(Men,cm_run,MF_ByCommand,cm_run,'Stop');
    DrawMenuBar(HWindow);
    Pool1^.CreateRAndomPool;
    Pool2^.CreateRAndomPool;
    ForEach(@ChildReset);
    StatusLine^.SetStatus('Reseting pools');
    TrialCount := 0;
    GetMem(buf,Info^.Bitlength+1);
    {--------------------------------------------------------------------------------------}
    Pool1^.Reset;
    Pool2^.Reset;
    Info^.Evals := 0;
    Info^.Generation := 1;
       ForEach(@ChildReset);
    Repeat
    Begin
      f := 0;
      StatusLine^.SetStatus('Evaluating population...');
      While (f < Pool1^.count )and (info^.running )do
      Begin
        cr := Pool1^.at(f);
        inc(f);
        If Cr^.Needs_evaluation then
        Begin
        While peekMessage(nMsg,0,0,0,pm_remove) Do
          If Msg.Message = wm_quit Then Halt
          Else if not Application^.ProcessAppMsg(nMsg) Then
          Begin
            TranslateMessage(nmsg);
            DispatchMessage(nmsg);
          End;
          inc(INfo^.evals);
          Eval^.Eval(cr,GeneList);
        end;
      End;
      StatusLine^.SetStatus('Calulating statistics...');
      Measure^.GetStats(Pool1);
      Pool1^.sort;
      ForEach(@ChildReady);
      If Info^.BitLength <> Info^.Lost Then
      Begin
        StatusLine^.SetStatus('Selecting best indviduals...');
        Select^.Select(Pool1,Pool2,info);
        StatusLine^.SetStatus('Creating children...');
        Cross^.Cross(pool2,Pool1,info);
        StatusLine^.SetStatus('Mutating children...');
        Mutate^.MutatePop(Pool1,info);
        inc(info^.Generation);
       End;
     End;
     Until (info^.BitLength = Info^.Lost) or (Info^.generation = Info^.MaxGen) or (not Info^.running);


    {--------------------------------------------------------------------------------------}
    If info^.BitLength = Info^.Lost Then
         StatusLine^.SetStatus('GA Converged');
    If info^.generation = Info^.MaxGen Then
         StatusLine^.SetStatus('Reached Maximum generation');
    If Not Info^.Running Then
         StatusLine^.SetStatus('GA Halted by user');
    Info^.Running := False;
    Graymenus;
    ForEach(@ChildEndRun);
    Men := GetMenu(HWindow);
    ModifyMenu(Men,cm_run,MF_ByCommand,cm_run,'Run');
    DrawMenuBar(HWindow);
  end;

End;

procedure TGENWindow.ViewTextStats(Var msg:TMessage);
Begin
  Application^.MakeWindow(New(PVText, Init(info,@Self,
    'Current Status')));
End;

procedure TGENWindow.ViewGraph1(Var msg:TMessage);
Begin
  Application^.MakeWindow(New(PProGraph, Init(info,@Self,
    'Fitness Progression')));
End;

procedure TGENWindow.ViewGraph2(Var msg:TMessage);
Begin
  Application^.MakeWindow(New(PDistGraph, Init(info,@Self,
    'Overall distribution of Fitness')));
End;

procedure TGENWindow.ViewGraph3(Var msg:TMessage);
Begin
 Application^.MakeWindow(New(PDistGraph2, Init(info,@Self,
    'Current distribution of Fitness')));
 { Application^.MakeWindow(New(PRouteGraph, Init(info,@Self,
    'Current best TSP route.')));    }
End;

procedure TGENWindow.CMAbout;
begin
  Application^.ExecDialog(New(PAbtDlg,Init(@Self,'About')));
end;

procedure TGENWindow.GAStatus;
begin
  Application^.ExecDialog(New(PStatusDlg,Init(@Self,'STATUS')));
end;

procedure TGENWindow.SetLog(Var msg:TMessage);
Begin
   Log^.ChangeSettings;
End;

{ Respond to "Open" command by constructing, creating, and setting up a
  new TFileWindow MDI chmild }
procedure TGENWindow.OpenFile(var Msg: TMessage);
var
  FileName: array[0..fsPathName] of Char;
begin
  if Application^.ExecDialog(New(PFileDialog, Init(@Self, PChar(sd_FileOpen),
      StrCopy(FileName, '*.Log')))) = id_Ok then
    Application^.MakeWindow(New(PFileEditor, Init(@Self, FileName)));
 {   Application^.MakeWindow(NEW(PChartWindow,init(@Self,'test')));  }
end;

{ Save the the position and contents of the windows to the
  "desk top" file. }
procedure TGENWindow.SaveState(var Msg: TMessage);
var
  S: PStream;

function FileDelete(Name: PChar): Integer; assembler;
asm
	PUSH	DS
	LDS	DX,Name
	MOV	AH,41H
	INT	21H
	JC	@@1
	XOR	AX,AX
@@1:	NEG	AX
	POP	DS
end;

begin
  S := New(PBufStream, Init(DskFile, stCreate, 1024));
  PutChildren(S^);
  if S^.Status <> stOk then
  begin
    Dispose(S, Done);
    FileDelete(DskFile);
    MessageBox(HWindow, 'Unable to write desktop file.', 'Disk error',
      mb_Ok or mb_IconExclamation);
  end
  else Dispose(S, Done);
end;

{ Read windows positions and contents from the "desk top" file. }
procedure TGENWindow.RestoreState(var Msg: TMessage);
var
  S: PStream;
  ErrorMsg: PChar;
begin
  ErrorMsg := nil;
  S := New(PBufStream, Init(DskFile, stOpenRead, 1024));
  if S^.Status <> stOk then
    ErrorMsg := 'Unable to open desktop file.'
  else
  begin
    CloseChildren;
    GetChildren(S^);
    if S^.Status <> stOk then
      ErrorMsg := 'Error reading desktop file.';
    if LowMemory then
    begin
      CloseChildren;
      ErrorMsg := 'Not enough memory to open file.'
    end
    else CreateChildren;
  end;
  if ErrorMsg <> nil then
    MessageBox(HWindow, ErrorMsg, 'Disk error', mb_Ok or mb_IconExclamation);
end;

{ Construct the TGENApp's MainWindow of type TGENWindow,
  loading its menu }
procedure TGENApp.InitMainWindow;
begin
  MainWindow := New(PGENWindow,Init('Win GA',
    LoadMenu(HInstance, 'Commands')));
  PGENWindow(MainWindow)^.ChildMenuPos := 3;

  { Register types to be written to stream }
  RegisterType(RWindow);
  RegisterType(REdit);
  RegisterType(RFileEditor);
end;

{ Initialize each MS-Windows application instance, loading an
  accelerator table }
procedure TGENApp.InitInstance;
begin
  TApplication.InitInstance;
  if Status = 0 then
  begin
    HAccTable := LoadAccelerators(HInstance, 'FileCommands');
    if HAccTable = 0 then
      Status := em_InvalidWindow;
  end;
end;



var
  GENApp : TGENApp;

begin
  GENApp.Init('WinGen-2');
  GENApp.Run;
  GENApp.Done;
end.
